<?php
/**
 * DanmarCRM Hubspot SugarCRM
 * 
 * Your installation or use of this file is subject to the applicable
 * terms available at
 * http://danmarcrm.com/licence.txt
 * If you do not agree to all of the applicable terms or do not have the
 * authority to bind the entity as an authorized representative, then do not
 * install or use this file.
 *
 * Copyright (C) NobleCRM Software All rights reserved.
 * 
 * PHP version 7
 *
@category SugarCRM
@package  DanmarCRM_Hubspot_Proxy
@author   DanmarCRM <dan@danmarcrm.com>
@license  http://danmarcrm.com/licence.txt
@link     https://DanmarCRM.com
@comment  danmar
/**
@return   void
 */
//ini_set("error_log", "__php_error_HS_SENDER.log");

//error_reporting(E_ALL);
//ini_set('display_errors', 'On');
// TO DO
/*when first create a deal in hs, send back to hs the created account 
to keep records ids */

require_once("custom/dmcHSHelper.php");

class dmcHSSender{
    var $optOut = "https://api.hubapi.com/email/public/v1/subscriptions/";
    
    function secHeader($ch){
		global $db;
        $query = "SELECT value FROM config WHERE category='dmc_hs_keys' AND name='hsDmcId'";
        $res = $db->query($query, true);
        $mod_dmcid = $db->fetchByAssoc($res);
        $dmcId = $mod_dmcid['value'];
        //$sign = http_build_query($dmcId);
        $signature = hash ("sha256",$dmcId);
        lg("putsignature: ".$signature." base: ".$dmcId);
        curl_setopt($ch, CURLOPT_HTTPHEADER, array('hbsreq: '.$signature));
        return $ch;        
        		
    }
    
    function putVal($bean,$fld,$val){
        if (method_exists($bean,"set")){
            $bean->set($fld,$val);    
        }else{
            $bean->$fld = $val;    
        }    
    }    
    function getVal($bean,$fld){
        global $db;
        if (method_exists($bean,"getFieldValue")){
            //print_r($bean);
            //echo "<br>\n ex: ".$bean->getFieldValue("hs_vid_c")." fld: ".$fld." id: ".$bean->getFieldValue("id");
            if ($fld == "hs_vid_c" or $fld == "hs_dealid_c"){
                if ($bean->getFieldValue($fld) == "" and $bean->getFieldValue("id") != ""){
                    $tblName = $bean->model->table_name;
                    if ($tblName != ""){
                        $tblName_cstm = $tblName."_cstm";
                            $sq = "select * from {$tblName_cstm} where id_c = '{$bean->getFieldValue("id")}'";
                            //echo "\n ".$sq;
                            $r = $db->query($sq);
                            $row = $db->fetchByAssoc($r);
                            if ($row[$fld] != ""){
                                $this->putVal($bean,$fld,$row[$fld]);    
                            }
                        //echo "<br>t: ".$tblName;    
                    }
                    //print_r($bean);
                    //exit();    
                }    
            }
            return $bean->getFieldValue($fld);    
        }else{
            return $bean->$fld = $val;    
        }    
    }
    
    function sendRequest($hsURL){
        global $db;
        $query = "SELECT value FROM config WHERE category='dmc_hs_keys' AND name='hsDmcUrl'";
        $res = $db->query($query, true);
        $mod_list = $db->fetchByAssoc($res);
        $dmcUrl = $mod_list['value'];
        
        $query = "SELECT value FROM config WHERE category='dmc_hs_keys' AND name='hsDmcId'";
        $res = $db->query($query, true);
        $mod_dmcid = $db->fetchByAssoc($res);
        $dmcId = $mod_dmcid['value'];
                        $data = array(
                                'mode' => 'getHSRecord',
                                'dmcId' => $dmcId,
                                'hsURL' => $hsURL
                        );
                    $resp = $this->sendObject($dmcUrl, $data);   
                    return $resp;            
    }    
    
    function procAct($bean, $a="",$b=""){
        lg("procAct");
        //$dbg = debug_backtrace(2);
        //lg($dbg);
        
        $act = new dmcHSSync("updAccount");  
        $act->crmOb = $bean;  
        $act->putHSValues(); 
        if ($bean->fetched_row['hs_vid_c'] == ""){ // ISSUE with SugarCRM 7.0 takes hsid from contact Check And Investigate MORE
            $bean->hs_vid_c = "";    
        }
        
        if (file_exists("include/config/local_config.php")){
            if (isset($_REQUEST['newaccount'])){       // ck if is 1CRM Conversion hs_vid_c is popoulated by copy_custom_field function 
                lg("newaccount newaccount");
                if ($_REQUEST['newaccount'] == 1){
                    $hdId = $this->getVal($bean,"hs_vid_c");
                    if ($hdId != ""){
                        $ckLeadID  = $this->checkExistingLead($hdId); 
                        if ($ckLeadID == ""){
                            $ckContactID = $this->checkExistingContact($hdId);    
                        }
                        if ($ckLeadID !="" or $ckContactID != ""){
                            $this->putVal($bean,"hs_vid_c","");
                            lg("newaccount reset");    
                        }       
                    }        
                }    
            }
        }
        /*        echo "<br>b: ".$bean->id;
        echo "<br>h: ".$bean->hs_vid_c;
        echo "<br><br><br>";
                    $a = debug_backtrace();
                    foreach ($a as $k=>$v){
                        echo "<br>file: ".$v['file'];
                        echo "<br>line: ".$v['line'];
                        echo "<br>function: ".$v['function']; 
                    }
                            
        print_r($bean);
        exit();*/
        if (count($act->hsProp) == 0){
            lg("procAct disabled integration");
            return false;    
        }        

            $comp['properties'] = $act->hsProp;
            $data = array(
                    'mode' => 'sendComp',
                    'companyId' => $this->getVal($bean,"hs_vid_c"),
                    'object' => $comp
            ); 
        $resUpd = $this->sendObject("", $data);   
        lg("procAct res : ".print_r($data,true));
        lg("procAct res : ".$resUpd);
        $res = json_decode($resUpd);
        if ($res->companyId != ""){
            if ($this->getVal($bean,"hs_vid_c") == ""){
                /*$bean->hs_vid_c = $res->companyId;*/
                $this->putVal($bean,"hs_vid_c",$res->companyId);
                if ($this->isCoversionSave($bean)){
                    lg("procAct isCoversionSave");
                    $ldId = $_REQUEST['record']; // lead is saved
                    $lead = BeanFactory::getBean("Leads",$ldId);  
                    /*$this->linkActTO($bean->hs_vid_c,$lead->hs_vid_c,2,0);*/    
                    $this->linkActTO($this->getVal($bean,"hs_vid_c"),$this->getVal($lead,"hs_vid_c"),2,0);    
                } 
            }
        }
   
                        //print_r($resUpd);
        //exit();
    }
    
    function procEngagement($bean, $a = "", $b = "")
    {
        lg("procEngagement");
        $base['engagement']['active'] = "true";
        //$base['engagement']['ownerId'] = 25256401;
        
        
        
        //$base['associations']['contactIds'] = array("2551");
        //$base['associations']['contactIds'] = array("2601"); 
        //$base['associations']['contactIds'] = array("2551"); 
        //timestamp
/*        $base['associations']['contactIds'] = array();
        $base['associations']['companyIds'] = array();
        $base['associations']['dealIds'] = array();
        $base['associations']['ownerIds'] = array();
        $base['associations']['ticketIds'] = array();*/


        $base['metadata'] = array();
        
        if ($bean->module_name == "Tasks"){
            $eng = new dmcHSSync("updTask");
            $base['engagement']['type'] = "TASK";
            if ($bean->date_due != ""){
                $base['engagement']['timestamp'] = strtotime($bean->date_due) * 1000;    
            }elseif($bean->date_start != ""){
                $base['engagement']['timestamp'] = strtotime($bean->date_start) * 1000;
            }
        }        
        if ($bean->module_name == "Meetings"){
            $eng = new dmcHSSync("updMeeting");
            $base['engagement']['type'] = "MEETING";
        }        
        if ($bean->module_name == "Calls"){
            $eng = new dmcHSSync("updCall");
            $base['engagement']['type'] = "CALL";
        }        
        if ($bean->module_name == "Emails"){
            $eng = new dmcHSSync("updEmail");
            $base['engagement']['type'] = "EMAIL";
        }        
        if ($bean->module_name == "Notes"){
            lg("sendObjectFile");
            $resNote = $this->sendObjectFile(array(),$bean);
            $resNoteObj = json_decode($resNote,true);
            lg($resNoteObj);
            if (is_array($resNoteObj) and isset($resNoteObj['objects']) and isset($resNoteObj['objects'][0]) and $resNoteObj['objects'][0]['id'] != ""){
                $fileID = $resNoteObj['objects'][0]['id'];    
                $base['attachments'][]['id'] = $fileID;
                $bean->hs_file_vid_c = $fileID;
            }
            
            
            $eng = new dmcHSSync("updNote");  
            $base['engagement']['type'] = "NOTE";
        }
        $eng->crmOb = $bean;
        $eng->putHSValuesEng();




        if ($bean->fetched_row['hs_vid_c'] == "") { // ISSUE with SugarCRM 7.0 takes hsid from contact Check And Investigate MORE       
            //$bean->hs_vid_c = "";
        }    
        //$base['engagement']['timestamp'] = $eng->putDateTimeBoolHSVal("date_start",$bean->date_start);

        
        

        if (count($eng->hsProp) == 0 and $bean->module_name != "Notes"){
            lg("procEng disabled integration");
            return false;    
        }
        $base['metadata'] = $eng->hsProp;
        $base['metadata']['forObjectType'] = "CONTACT";
        $base['metadata']['body'] = $bean->description;
        $base['engagement']['status'] = $base['metadata']['status'];
        if ($base['metadata']['hubspot_owner_id'] != ""){
            $base['engagement']['ownerId'] = $base['metadata']['hubspot_owner_id'];
            unset($base['metadata']['hubspot_owner_id']);
        }
        if ($bean->module_name == "Meetings"){
            $base['metadata']['startTime'] = strtotime($bean->date_start) * 1000;    
            $base['metadata']['endTime'] = strtotime($bean->date_end) * 1000;    
        }
        if ($bean->module_name == "Calls"){
            $base['metadata']['startTime'] = strtotime($bean->date_start) * 1000;    
            $base['metadata']['endTime'] = strtotime($bean->date_end) * 1000;
            if ($base['metadata']['startTime'] != "" and $base['metadata']['endTime'] != ""){
                $duration = strtotime($bean->date_end) - strtotime($bean->date_start);
                $base['metadata']['durationMilliseconds'] = $duration;    
            }    
            $base['metadata']['body'] = $bean->name;    
                        
        }
        if ($bean->module_name == "Emails"){
            $base['metadata']['from']['email'] = $bean->from_addr_name;          
            $base['metadata']['to']['email'] = $bean->contact_email;      
            $base['metadata']['subject'] = $bean->name;      
            $base['metadata']['html'] = $bean->description_html;    
            $base['metadata']['text'] = $bean->description;    
            unset($base['metadata']['status']);
                        
        }
        //$base['engagement']['ownerId'] = "183345089";
        //$base['engagement']['ownerId'] = "188987578";
        
        //$base['metadata']['status'] = "NOT_STARTED";
        $data = array(
            'mode' => 'sendEngagement',
            'engagementId' => $bean->hs_vid_c,
            
            'object' => $base
        );
        $resUpd = $this->sendObject("", $data);
        #lgMod(json_encode($data),$resUpd);
        lg("procEng res : " . print_r($data, true));
        lg("procEng res : " . $resUpd);
        $res = json_decode($resUpd);
        lg($res);
        if (is_object($res->engagement) and $res->engagement->id != "") {
            if ($bean->hs_vid_c == "") {
                $bean->hs_vid_c = $res->engagement->id;
            }
        }
        if ($bean->parent_type == "Contacts" and $bean->parent_id != "" and $bean->hs_vid_c != ""){
            $relCt = $eng->getSugarRowByID("contacts",$bean->parent_id); 
            if ($relCt['hs_vid_c'] != ""){
                $this->linkActTO($relCt['hs_vid_c'], $bean->hs_vid_c, 9, 0);    
            } 
        }
        if ($bean->contact_id != "" and $bean->hs_vid_c != ""){
            $relCt = $eng->getSugarRowByID("contacts",$bean->contact_id); 
            if ($relCt['hs_vid_c'] != ""){
                $this->linkActTO($relCt['hs_vid_c'], $bean->hs_vid_c, 9, 0);    
            } 
        }

        if ($bean->parent_type == "Accounts" and $bean->parent_id != "" and $bean->hs_vid_c != ""){
            $relAct = $eng->getSugarRowByID("accounts",$bean->parent_id); 
            if ($relAct['hs_vid_c'] != ""){
                $this->linkActTO($relAct['hs_vid_c'], $bean->hs_vid_c, 7, 0);    
            } 
        }
        lg("parent type: ".$bean->parent_type );
        if ($bean->parent_type == "Opportunities" and $bean->parent_id != "" and $bean->hs_vid_c != ""){
            $relOpp = $eng->getSugarRowByID("opportunities",$bean->parent_id); 
            if ($relOpp['hs_dealid_c'] != ""){
                $this->linkActTO($relOpp['hs_dealid_c'], $bean->hs_vid_c, 11, 0);   
                if ($relOpp['account_id'] != ""){ 
                    $relAct = $eng->getSugarRowByID("accounts",$relOpp['account_id']); 
                    if ($relAct['hs_vid_c'] != ""){
                        $this->linkActTO($relAct['hs_vid_c'], $bean->hs_vid_c, 7, 0);    
                    }
                }
            } 
        }                

        //print_r($resUpd);
        //exit();
    }
    
    /**
     * Get Campaign SQL
     *
     * @return string
     */
    function getCampaignSQL($id)
    {
        $sq = "select * from campaigns where id = '{$id}'";
        return $sq;
    }    
    
    /**
     * Get Campaign by ID
     *
     * @return string
     */
    function getCampaignByID($id)
    {
        global $db;
        $sq = $this->getCampaignSQL($id);
        $r = $db->query($sq);
        
        $row = $db->fetchByAssoc($r);
        return $row;
    }        
    
    function checkExistingContact($id){
        global $db;    
        $sq = "select * from contacts left join contacts_cstm on id = id_c where deleted = 0 and hs_vid_c = '{$id}' and hs_vid_c != ''";
        lg("\n ".$sq);
        $r = $db->query($sq,true);
        $row = $db->fetchByAssoc($r);
            if ($row['id'] != ""){
            return $row['id'];
            }
    }    
    function checkExistingLead($id){
        global $db;    
        $sq = "select * from leads left join leads_cstm on id = id_c where deleted = 0 and hs_vid_c = '{$id}' and hs_vid_c != ''";
        $r = $db->query($sq,true);
        $row = $db->fetchByAssoc($r);
            if ($row['id'] != ""){
            return $row['id'];
            }
    }    
    function getExistingLead($id){
        global $db;    
        $sq = "select * from leads left join leads_cstm on id = id_c where deleted = 0 and id = '{$id}'";
        $r = $db->query($sq,true);
        $row = $db->fetchByAssoc($r);
        return $row;
    }    
    
    function delObjects($bean){
        if (file_exists("include/config/local_config.php")){
            $module_name = $bean->model->module_dir;    
        }else{
            $module_name = $bean->module_name;    
        }
        lg("delObjects: ".$module_name);
        if ($module_name == "Opportunities"){
            if ($this->getVal($bean,"hs_dealid_c") != ""){
                //Returns a 204 No Content response on success. !!
                /*$url = "https://api.hubapi.com/deals/v1/deal/".$bean->hs_dealid_c;*/      
                $url = "https://api.hubapi.com/deals/v1/deal/".$this->getVal($bean,"hs_dealid_c");      
            } 
        }
        if ($module_name == "Leads"){
            if ($this->getVal($bean,"hs_vid_c") != ""){
                $url = "https://api.hubapi.com/contacts/v1/contact/vid/".$this->getVal($bean,"hs_vid_c");      
            } 
        }
        if ($module_name == "Contacts"){
            if ($this->getVal($bean,"hs_vid_c") != ""){
                $url = "https://api.hubapi.com/contacts/v1/contact/vid/".$this->getVal($bean,"hs_vid_c");      
            } 
        }
        if ($module_name == "Accounts"){
            if ($this->getVal($bean,"hs_vid_c") != ""){
                $url = "https://api.hubapi.com/companies/v2/companies/".$this->getVal($bean,"hs_vid_c");      
            }
            
            
        }
            $data = array(
                    'mode' => 'delRecord',
                    'delUrl' => $url,
            ); 
        $resUpd = $this->sendObject($dmcUrl, $data);
        if (file_exists("include/config/local_config.php")){
            unset($bean->updates['hs_vid_c']);
            unset($bean->updates['hs_dealid_c']);
        }   
        //print_r($bean);
        //exit();             
    }    
    function linkActTO($accId,$ldId,$definitionID,$delete){
        //2 Company to contact
        if ($accId == "" or $ldId == ""){ // don't send empty requests
            return false;    
        }
            $data = array(
            'mode' => 'sendAssociation',
            'fromObjectId' => $accId,
            'toObjectId' => $ldId,
            'category' => 'HUBSPOT_DEFINED',
            'definitionId' => $definitionID
    );
    if ($delete){
        $data['mode'] = "delAssociation";    
    }
    $cComp = $this->sendObject("", $data);
    lg("linkActTO : ".print_r($data,true));
    lg("linkActTO resp: ".$cComp);
    }
    
    function ckIsConvert($dbg){
        foreach ($dbg as $k=>$v){
            if ($v['class'] == "LeadConvertApi"){
                return true;    
            }
        }
        if (isset($_REQUEST['newaccount']) and isset($_REQUEST['newopp'])){
            return true;     
        }
        if (isset($_REQUEST['action']) and $_REQUEST['action'] == "SaveWithRelates" and isset($_REQUEST['rel_lead_id'])){
            return true;     
        }
        return false;
    }
    
    function procLead($bean, $type){
        lg("procLead");
        if (isset($_REQUEST['noprocLead'])){ 
            return false;    
        }        
        $dbgIsConvert = debug_backtrace(2);
        $isConvert = $this->ckIsConvert($dbgIsConvert);
        if ($bean->table_name == "leads") {
            if ($bean->orig_row['opportunity_id'] == "" and $bean->opportunity_id != "") {  // conversion of lead we have opp
                $oppObj = BeanFactory::getBean("Opportunities", $bean->opportunity_id);
                $this->linkActTO($bean->hs_vid_c, $oppObj->hs_dealid_c, 4, 0);

                if ($bean->orig_row['account_id'] == "" and $bean->account_id != "") {  // conversion of lead we have opp
                    $accObj = BeanFactory::getBean("Accounts", $bean->account_id);
                    $this->linkActTO($accObj->hs_vid_c, $oppObj->hs_dealid_c, 6, 0);
                }
            }

        }
        //NEEDS 1CRM Conv        
        if (file_exists("include/config/local_config.php")){
            if ($isConvert and $bean->model->name == "Contact" and $_REQUEST['rel_lead_id'] != ""){
                $convLead = $this->getExistingLead($_REQUEST['rel_lead_id']);     
                if ($convLead['hs_vid_c'] != ""){
                    $this->putVal($bean,"hs_vid_c",$convLead['hs_vid_c']);
                    lg("procLead convert ".$convLead['hs_vid_c']);    
                }   
            }
        }
		$campaignName = $this->getCampaignByID($bean->campaign_id);
		
        lg("procLead table: ".$bean->model->table_name);
        if (file_exists("include/config/local_config.php")){
            if ($bean->model->table_name == "leads"){
            	$tblName = $bean->model->table_name;
            }           
        }else{
            $tblName = $bean->table_name;
        }

        $beanOldOppid = $bean->orig_row['opportunity_id'];
        $beanCurrentOppid = $this->getVal($bean,"opportunity_id");
        $beanCurrentAccid = $this->getVal($bean,"account_id");

        if ($tblName == "leads"){
            
            if ($beanOldOppid == "" and $beanCurrentOppid != ""){  // conversion of lead we have opp
                $oppObj = BeanFactory::getBean("Opportunities",$beanCurrentOppid);
                /*$this->linkActTO($bean->hs_vid_c,$oppObj->hs_dealid_c,4,0);*/   
                $this->linkActTO($this->getVal($bean,"hs_vid_c"),$this->getVal($oppObj,"hs_dealid_c"),4,0);   
                 
                if ($bean->orig_row['account_id'] == "" and $beanCurrentAccid != ""){  // conversion of lead we have opp
                    $accObj = BeanFactory::getBean("Accounts",$beanCurrentAccid);
                    /*$this->linkActTO($accObj->hs_vid_c,$oppObj->hs_dealid_c,6,0); */   
                    $this->linkActTO($this->getVal($accObj,"hs_vid_c"),$this->getVal($accObj,"hs_dealid_c"),6,0);    
                }
            }

        }
        //exit();
        if ($_REQUEST['NOHOOKS']==TRUE){
            //return false;
        }   
        $lead = new dmcHSSync($type);
        $bean->hs_lifecyclestage_c = "lead";  
        $lead->crmOb = $bean;  
        $lead->putHSValues("property");
        if (count($lead->hsProp) == 0){
            lg("procLead disabled integration: ".$type);
            return false;    
        }          
        if (count($lead->hsProp) > 0){
            $comp['properties'] = $lead->hsProp;
            $data = array(
                    'mode' => 'sendLead',
                    /*'vidId' => $bean->hs_vid_c, */
                    'vidId' => $this->getVal($bean,"hs_vid_c"),
                    'object' => $comp
            ); 
            //print_r($data);
            //exit();
        $resUpd = $this->sendObject($dmcUrl, $data);  
        lg("procLead : ".print_r($data,true));    
        lg("procLead resp : ".$resUpd);      
        $res = json_decode($resUpd);
        //Needs 1CRM Conv
            if (isset($res->message) and $res->message == "Contact already exists"){  
                if (isset($res->identityProfile) and is_object($res->identityProfile)){
                    if (isset($res->identityProfile->vid) and $res->identityProfile->vid != ""){
                        global $db;
                        $sq = "select * from config where category='dmc_hs_keys' and name='matchExistingRecord'";
                        $rMatch=$db->query($sq); 
                        $rowMatch=$db->fetchByAssoc($rMatch); 
                        if ($rowMatch['value'] == "on"){
                            if ($bean->hs_vid_c == "") {
                                $bean->hs_vid_c = $res->identityProfile->vid;
                            }                            
                        }                                           
                    }    
                }    
            }        
	        if ($res->vid != ""){
	            if ($this->getVal($bean,"hs_vid_c") == ""){
	                $this->putVal($bean,"hs_vid_c",$res->vid);
	            }
	        }
		}

        if ($lead->getCRMVal("account_id") != ""){
            $acc = BeanFactory::getBean("Accounts",$this->getVal($bean,"account_id"));
            /*if ($acc->hs_vid_c != ""){ */
            if ($this->getVal($acc,"hs_vid_c") != ""){
                $data = array(
                'mode' => 'sendAssociation',
                /*'fromObjectId' => $acc->hs_vid_c,
                'toObjectId' => $bean->hs_vid_c, */
                'fromObjectId' => $this->getVal($acc,"hs_vid_c"),
                'toObjectId' => $this->getVal($bean,"hs_vid_c"), 
                'category' => 'HUBSPOT_DEFINED',
                'definitionId' => 2
                );
                lg("procLead Account : ".$dmcUrl." data: ".print_r($data,true));
                $cComp = $this->sendObject($dmcUrl, $data); 
            }           
        }
        lg("link opp to ct: ".print_r($_REQUEST['link_opportunities_contacts'],true));
        if (isset($_REQUEST['link_opportunities_contacts'])){ // this is an contact related to an opp in subpanel
        lg("link opp to ct beanid : ".$bean->id);
            if ($_REQUEST['link_opportunities_contacts']['ct'] == $bean->id and $_REQUEST['link_opportunities_contacts']['opp'] != ""){
                $opp = BeanFactory::getBean("Opportunities",$_REQUEST['link_opportunities_contacts']['opp']);
                lg("link opp to ct dealid : ".$opp->hs_dealid_c);
                    if ($opp->hs_dealid_c != ""){
                        lg("link opp to ct beanhsvid : ".$this->getVal($bean,"hs_vid_c"));
                    /*$this->linkActTO($bean->hs_vid_c,$opp->hs_dealid_c,4,0);*/     
                    $this->linkActTO($this->getVal($bean,"hs_vid_c"),$this->getVal($opp,"hs_dealid_c"),4,0);     
                    }        
            }
            unset($_REQUEST['link_opportunities_contacts']);   
        }   
        $this->ckOptOut($bean);     
    }
    
    function ckOptOut($bean){
        if ($this->getVal($bean,"email_opt_out") == true){
            $v['email_address'] = $this->getVal($bean,"email1");
            $this->unsubscribeEmail($v);     
        }
        foreach ($bean->emailAddress->addresses as $k => $v) {
            $foundOut = false;
            if ($v['opt_out'] == true) {
                foreach ($bean->fetched_row['email'] as $k1 => $v1) {
                    if ($v1['email_address'] == $v['email_address']) {  // found address in old db val
                        if ($v1['opt_out'] == false) {  // it is first time when we unsubscribe
                            $foundOut = true;
                            //echo "<br>Out";
                            $this->unsubscribeEmail($v);
                            //exit();   
                        }
                    }
                }
                if (!$foundOut) {  // if is first time when email is saved with opt out flag
                    $this->unsubscribeEmail($v);
                }
            }
        }
    }
    
    function unsubscribeEmail($email)
    {
        $optOut = $this->optOut; 
        $send['unsubscribeFromAll'] = true;
        $optOut = $optOut."".$email['email_address'];   
            $data = array(
                    'mode' => 'optOutEmail',
                    'hsURL' => $optOut,
                    'sendToHS' => json_encode($send),
            ); 

        $resUpd = $this->sendObject($optOut, $data);
        lg($resUpd);        
        
    }
    function covertCto1CRMRel($rel){
        $ret['relationship'] = $rel->model->name;    
        $ret['relationship'] = $rel->model->name;    
        $ret['module'] = $rel->model->module_dir;
        //print_r($rel->input);
        //exit();
            if ($rel->model->name == "accounts_contacts"){    
                $ret['id'] = $rel->input['account_id'];    
                $ret['related_id'] = $rel->input['contact_id'];    
            }
            if ($rel->model->name == "accounts_opportunities"){    
                $ret['id'] = $rel->input['account_id'];    
                $ret['related_id'] = $rel->input['opportunity_id'];    
            }
            if ($rel->model->name == "opportunities_contacts"){    
                $ret['related_id'] = $rel->input['contact_id'];    
                $ret['id'] = $rel->input['opportunity_id'];    
            }
        return $ret;
    }
    
    function convert1CRMTReq(){
        //print_r($_REQUEST);
        
        if ($_REQUEST['module'] == "Opportunities" and $_REQUEST['link_name'] == "contacts"){
            $rel['relationship'] = "opportunities_contacts";
            $rel['module'] = "Contacts";    
            $rel['id'] = $_REQUEST['link_id'];    
            $rel['related_id'] = $_REQUEST['record'];    
        }
        if ($_REQUEST['module'] == "Contacts" and $_REQUEST['link_name'] == "opportunities"){
            $rel['relationship'] = "opportunities_contacts";
            $rel['module'] = "Contacts";    
            $rel['id'] = $_REQUEST['record'];    
            $rel['related_id'] = $_REQUEST['link_id'];    
        }
        if ($_REQUEST['module'] == "Contacts" and $_REQUEST['link_name'] == "accounts"){
            $rel['relationship'] = "accounts_contacts";
            $rel['module'] = "Accounts";    
            $rel['id'] = $_REQUEST['link_id'];    
            $rel['related_id'] = $_REQUEST['record'];    
        }
        if ($_REQUEST['module'] == "Accounts" and $_REQUEST['link_name'] == "contacts"){
            $rel['relationship'] = "accounts_contacts";
            $rel['module'] = "Accounts";    
            $rel['id'] = $_REQUEST['record'];    
            $rel['related_id'] = $_REQUEST['link_id'];    
        }
        if ($_REQUEST['module'] == "Accounts" and $_REQUEST['link_name'] == "opportunities"){
            $rel['relationship'] = "accounts_opportunities";
            $rel['module'] = "Accounts";    
            $rel['id'] = $_REQUEST['record'];    
            $rel['related_id'] = $_REQUEST['link_id'];    
        }
        if ($_REQUEST['module'] == "Opportunities" and $_REQUEST['link_name'] == "accounts"){
            $rel['relationship'] = "accounts_opportunities";
            $rel['module'] = "Accounts";    
            $rel['id'] = $_REQUEST['link_id'];    
            $rel['related_id'] = $_REQUEST['record'];    
        }
        return $rel;
    }                                                        
    
    function linkObjects($rel,$event){
        if (is_object($rel)){ // 1crm vs sugarcrm
            $rel = $this->covertCto1CRMRel($rel);  
            lg("converted rel: ".print_r($rel,true));  
        }
        if (file_exists("include/config/local_config.php")){
            if (isset($_REQUEST['record_perform'])){
                if ($_REQUEST['record_perform'] == "subpanel_remove"){
                    $rel = $this->convert1CRMTReq(); 
                    $event = "before_relationship_delete";   
                }    
            }
        }
        if ($event == "before_relationship_delete"){
            $delete = true;    
        }else{
            $delete = false;      
        }
        lg("linkObjects : ".print_r($rel,true));
        if ($rel['relationship'] == "accounts_contacts"){
                if ($rel['module'] == "Accounts"){
                    $acc = $rel['id'];  
                    $cnt = $rel['related_id'];  
                }else{
                    $acc = $rel['related_id'];
                    $cnt = $rel['id'];  
                }
                
                $accObj = BeanFactory::getBean("Accounts",$acc);
                $cntObj = BeanFactory::getBean("Contacts",$cnt);
                /*lg("linkObjects 2a:".$accObj->hs_vid_c." ".$cntObj->hs_vid_c);*/ 
                lg("linkObjects 2a:".$this->getVal($accObj,"hs_vid_c")." ".$this->getVal($cntObj,"hs_vid_c")); 
                    if ($this->getVal($accObj,"hs_vid_c") != "" and $this->getVal($cntObj,"hs_vid_c") != ""){
                        $this->linkActTO($this->getVal($accObj,"hs_vid_c"),$this->getVal($cntObj,"hs_vid_c"),2,$delete);
                        lg("linkObjects 2b:".$this->getVal($accObj,"hs_vid_c")." ".$this->getVal($cntObj,"hs_vid_c"));   
                    }
               
        }
        
        if ($rel['relationship'] == "accounts_opportunities"){
                if ($rel['module'] == "Accounts"){
                    $acc = $rel['id'];  
                    $opp = $rel['related_id'];  
                }else{
                    $acc = $rel['related_id'];
                    $opp = $rel['id'];  
                }
                
                $accObj = BeanFactory::getBean("Accounts",$acc);
                $oppObj = BeanFactory::getBean("Opportunities",$opp);
/*                echo "<br>\n ".$opp;
                echo "<br>acc: ".$this->getVal($accObj,"hs_vid_c")." opp: ".$oppObj->id." oppsid: ".$opp;*/
                    /*lg("linkObjects 6a:".$this->getVal($accObj,"hs_vid_c")." ".$oppObj->hs_dealid_c);*/
                    lg("linkObjects 6a:".$this->getVal($accObj,"hs_vid_c")." ".$this->getVal($oppObj,"hs_dealid_c"));
                    if ($this->getVal($accObj,"hs_vid_c") != "" and $this->getVal($oppObj,"hs_dealid_c") != ""){
                        $this->linkActTO($this->getVal($accObj,"hs_vid_c"),$this->getVal($oppObj,"hs_dealid_c"),6,$delete);
                        lg("linkObjects 6b:".$this->getVal($accObj,"hs_vid_c")." ".$this->getVal($oppObj,"hs_dealid_c"));       
                    }
               
        }        
        if ($rel['relationship'] == "opportunities_contacts"){
                if ($rel['module'] == "Contacts"){
                    $ct = $rel['id'];  
                    $opp = $rel['related_id'];  
                }else{
                    $ct = $rel['related_id'];
                    $opp = $rel['id'];  
                }
                
                $ctObj = BeanFactory::getBean("Contacts",$ct);
                $oppObj = BeanFactory::getBean("Opportunities",$opp);        
                /*lg("linkObjects 4a ct:".$ctObj->hs_vid_c." opp: ".$oppObj->hs_dealid_c." ctid: ".$ct); */   
                lg("linkObjects 4a ct:".$this->getVal($ctObj,"hs_vid_c")." opp: ".$this->getVal($oppObj,"hs_dealid_c")." ctid: ".$ct);    
                    if ($this->getVal($ctObj,"hs_vid_c") != "" and $this->getVal($oppObj,"hs_dealid_c") != ""){
                        $this->linkActTO($this->getVal($ctObj,"hs_vid_c"),$this->getVal($oppObj,"hs_dealid_c"),4,$delete);  
                        lg("linkObjects 4b:".$this->getVal($ctObj,"hs_vid_c")." ".$this->getVal($oppObj,"hs_dealid_c")); 
                    }else{
                        $_REQUEST['link_opportunities_contacts']['ct'] = $ct;  // workaround for sugar10 where relationship is created before contact
                        $_REQUEST['link_opportunities_contacts']['opp'] = $opp;
                    }
               
        }    
    }
    
        function procOpp($bean, $a="",$b=""){
        lg("procOpp dmcHsSender");
        /*$acc = BeanFactory::getBean("Accounts",$bean->account_id);*/
        $acc = BeanFactory::getBean("Accounts",$this->getVal($bean,"account_id"));
        if ($_REQUEST['action'] == "ConvertLead"){  //if save from Convert Lead
            if ($_REQUEST['module'] == "Leads" and $_REQUEST['record'] != ""){
            $lead = BeanFactory::getBean("Leads",$_REQUEST['record']);     
            }
        }
        $s10Req = file_get_contents("php://input");
        $s10Req = json_decode($s10Req);
        /*lg("lead: ".$lead->id." hsvid: ".$lead->hs_vid_c);*/
        lg("lead: ".$this->getVal($lead,"id")." hsvid: ".$this->getVal($lead,"hs_vid_c"));
        $opp = new dmcHSSync("updDeal");  
        $opp->crmOb = $bean;  
        $opp->putHSValues();  
        $dmcUrl = $this->getHSInfo("hsDmcUrl");
        $dmcId = $this->getHSInfo("hsDmcId");
		$leadID = "";
		$acctID = "";
        if (count($opp->hsProp) == 0){
            lg("procOpp disabled integration");
            return false;    
        }
        $comp['properties'] = $opp->hsProp;
        if (is_object($acc) and isset($acc->hs_vid_c))
        	$acctID = $acc->hs_vid_c;
        if (isset($lead) and isset($lead->hs_vid_c))
        	$leadID = $lead->hs_vid_c;        
            $comp['associations'] = array(
                'associatedCompanyIds' => array(intval($this->getVal($acc,"hs_vid_c"))),
                'associatedVids' => array(intval($this->getVal($lead,"hs_vid_c")))
                );
            $data = array(
                'mode' => 'sendOpportunity',
                'dmcId' => $dmcId,
                'vidId' => $this->getVal($bean,"hs_dealid_c"),
                'object' => $comp
            ); 
            lg($data);
            $resUpd = $this->sendObject($dmcUrl, $data);
            lg("procOpp : ".print_r($data,true));
            lg("procOpp resp : ".$resUpd);
            lg("after save REQ: ".print_r($_REQUEST,true));
            
            $decRes = json_decode($resUpd);
            if($decRes->dealId != ""){
                /*$bean->hs_dealid_c = $decRes->dealId;*/
                $this->putVal($bean,"hs_dealid_c",$decRes->dealId);
                    if (isset($_REQUEST['link_opportunities_contacts'])){ // this is an opportunity related to an contact in subpanel
                    lg("link opp to ct beanid : ".$this->getVal($bean,"id"));
                        if ($_REQUEST['link_opportunities_contacts']['opp'] == $this->getVal($bean,"id") and $_REQUEST['link_opportunities_contacts']['ct'] != ""){
                            $ct = BeanFactory::getBean("Contacts",$_REQUEST['link_opportunities_contacts']['ct']);
                            lg("link opp to ct dealid : ".$this->getVal($bean,"hs_dealid_c"));
                                /*if ($bean->hs_dealid_c != ""){*/
                                if ($this->getVal($bean,"hs_dealid_c") != ""){
                                    /*lg("link opp to ct beanhsvid : ".$bean->hs_vid_c); */
                                    /*$this->linkActTO($ct->hs_vid_c,$bean->hs_dealid_c,4,0);*/     
                                    $this->linkActTO($this->getVal($ct,"hs_vid_c"),$this->getVal($bean,"hs_dealid_c"),4,0);     
                                }        
                        }
                        unset($_REQUEST['link_opportunities_contacts']);   
                    }                
                
                //$this->updateOppDealId($bean->id,$decRes->dealId);  ?? DAN ENABLE FOR sugar 6.5 ?!?
            }          
    }
    
    
    function updateOppDealId($id,$hsId){
        global $db;
        $sq = "select * from opportunities_cstm where id_c = '{$id}'";
        $r = $db->query($sq);
        $row = $db->fetchByAssoc($r);
            if ($row['id_c']==""){
                $sq = "insert into opportunities_cstm (id_c,hs_dealid_c) values ('{$id}','{$hsId}')";
            }else{
                $sq = "update opportunities_cstm SET hs_dealid_c = '{$hsId}' WHERE id_c = '{$id}'";    
            }
            $db->query($sq, true);
    }
    
    function isCoversionSave($bean){
        if($bean->object_name == 'Account' and $_REQUEST['record'] != '' and $_REQUEST['action'] == 'ConvertLead'){
            return true;
        }
    }
    
	function lgDmc($url,$send,$ans){
        if (file_exists("modules/dmc_log/dmc_log.php")){
            require_once("modules/dmc_log/dmc_log.php");
            $d = new dmc_log();
            $d->logSendReq($url,$send,$ans);
        }
    }
    
	function sendObject($dmcUrl, $data)
	{
        
		$dataSend = json_encode($data);
        $dmcUrl = $this->getHSInfo("hsDmcUrl");
        $dmcId = $this->getHSInfo("hsDmcId");
        $data['dmcId'] = $dmcId;		
		$ch = curl_init();
		curl_setopt($ch, CURLOPT_URL,$dmcUrl);
		curl_setopt($ch, CURLOPT_POST, 1);
		curl_setopt($ch, CURLOPT_POSTFIELDS,
				http_build_query($data));
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
		$result = curl_exec($ch);
		$err = curl_error($ch);
		curl_close($curl);
        $a = debug_backtrace(2);
        lg("sendObject: ".$dmcUrl);
        lg($data);
        //file_put_contents("__dddbgSOcheckExsiting.log","\n reqMode: ".$_REQUEST['dmcMode']."\n ---sendObject: ".print_r($a,true)." \n\n trace: ",FILE_APPEND);
		$this->lgDmc($dmcUrl,$data,$result);
		return $result;
		
	}

    function sendObjectFile($dmcUrl, $bean)
    {
        //return false;
        $filePath = "upload/".$bean->id;
        lg("sendObjectFile path: ".$filePath);
        if (!sugar_is_file($filePath)){
            lg("sendObjectFile no file path: ".$filePath);
            return false;    
        }
        $upload_file = new CURLFile($filePath,'application/octet-stream');
        $file_options = array(
            "access" => "PUBLIC_INDEXABLE",
            "ttl" => "P3M",
            "overwrite" => false,
            "duplicateValidationStrategy" => "NONE",
            "duplicateValidationScope" => "ENTIRE_PORTAL"
        );
        $data['dmcId'] = $dmcId;
        $data['file'] = $upload_file;
        $data['existingFileId'] = $bean->hs_file_vid_c;
        $data['filename'] = $bean->filename;
        $data['mode'] = "sendFile";
        $data['options'] = json_encode($file_options);
        $data['folderPath'] = "/docs";
/*        $post_data = array(
            "file" => $upload_file,
            "mode" => "sendFile",
            "options" => json_encode($file_options),
            "folderPath" => "/docs"
        );*/        
            
        $dataSend = json_encode($data);
        $dmcUrl = $this->getHSInfo("hsDmcUrl");
        $dmcId = $this->getHSInfo("hsDmcId");
        $data['dmcId'] = $dmcId;
        $ch = curl_init();
        $ch = $this->secHeader($ch);
        curl_setopt($ch, CURLOPT_URL, $dmcUrl);
        curl_setopt($ch, CURLOPT_POST, 1);
        curl_setopt($ch, CURLOPT_POSTFIELDS, $data);
        /*        curl_setopt($ch, CURLOPT_POSTFIELDS,
            http_build_query($data));*/
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        $result = curl_exec($ch);
        $err = curl_error($ch);
        curl_close($ch);
        //$a = debug_backtrace(2);
        lg("sendObject: " . $dmcUrl);
        lg($data);
        lg("resultFile: ".$result);
        $this->lgDmc($dmcUrl, $data, $result); 
        lgMod(json_encode($data),$result);
        return $result;

    }
	
	function getHSInfo($prop){
        global $db;
        $query = "SELECT value FROM config WHERE category='dmc_hs_keys' AND name='{$prop}'";
        $res = $db->query($query, true);
        $mod_list = $db->fetchByAssoc($res);
        $ret = $mod_list['value'];        
        return $ret;
    }
    

}

if (!class_exists("BeanFactory")){
    class BeanFactory{
        function getBean($crmModule,$id){
            $crmModule = self::correctModuleName($crmModule);
            $bean = RowUpdate::blank_for_model($crmModule);
            $bean->retrieveRecord($id);
            return $bean;    
        }
        
        function correctModuleName($crmModule){
            if ($crmModule == "Accounts")
            return "Account";
            if ($crmModule == "Contacts")
            return "Contact";
            if ($crmModule == "Leads")
            return "Lead";
            if ($crmModule == "Opportunities")
            return "Opportunity";    
        }    
    }    
}


?>