<?php
/**
 * DanmarCRM Hubspot SugarCRM
 * 
 * Your installation or use of this file is subject to the applicable
 * terms available at
 * http://danmarcrm.com/licence.txt
 * If you do not agree to all of the applicable terms or do not have the
 * authority to bind the entity as an authorized representative, then do not
 * install or use this file.
 *
 * Copyright (C) NobleCRM Software All rights reserved.
 * 
 * PHP version 7
 *
@category SugarCRM
@package  DanmarCRM_Hubspot
@author   DanmarCRM <dan@danmarcrm.com>
@license  http://danmarcrm.com/licence.txt
@link     https://DanmarCRM.com
@comment  danmar
/**
 * Implements hook_help().
@return   void
 */
/**
 * Implements hook_help().
 * @return   void
 */
 
//error_reporting(-1);

require_once "custom/dmcHSSender.php";

global $hubspot_1crm;
global $hubspot_1crm_cstm;
global $hs_lifecyclestage_arr;
global $hubspot_1crm_amend;
global $read_only_hs_arr;
global $hubspot_1crm_acc;
global $hsTaskFields;
global $hsMeetingFields;
global $hsNoteFields;
global $hsCallFields;
global $hubspot_1crm_acc, $hsSStoCRMStage, $hs1CRMOpp, $dateFields, $dropDownFlds;

$hubspot_1crmT = array(
    // 'salutation'         => 'salutation',
    'firstname' => 'first_name',
    'lastname' => 'last_name',
    'email' => 'email1',
    'phone' => 'phone_work',
    'fax' => 'phone_fax',
    'address' => 'primary_address_street');

$hubspot_1crm = array(
    // 'salutation'         => 'salutation',
    'firstname' => 'first_name',
    'lastname' => 'last_name',
    'email' => 'email1',
    'phone' => 'phone_work',
    'fax' => 'phone_fax',
    'address' => 'primary_address_street',
    'city' => 'primary_address_city',
    'state' => 'primary_address_state',
    'zip' => 'primary_address_postalcode',
    'country' => 'primary_address_country',
    'crm_lead_source' => 'lead_source',          
    'capsp_opted_comm' => 'opted_in_for_communication',          
    'status' => 'hs_lead_status',          

    'LEAD_GUID' => 'hs_guid_c',
    'vid' => 'hs_vid_c',
    'portal-id' => 'hs_portal_id_c',
    'createdate' => 'hs_createdate_c', //date
    'lastmodifieddate' => 'hs_lastmodifieddate_c', //date
    'lifecyclestage' => 'hs_lifecyclestage_c', //dropdown - hs_lifecyclestage_list
    'ipaddress' => 'hs_ipaddress_c',
    // 'company'             => 'hs_company_c',
    'company' => 'account_name',
    'website' => 'hs_website_c',
    'jobtitle' => 'title',
    'annualrevenue' => 'hs_annualrevenue_c',
    'numemployees' => 'hs_numemployees_c',

    'twitterhandle' => 'hs_twitterhandle_c',
    'kloutscoregeneral' => 'hs_kloutscoregeneral_c',
    'hs_social_linkedin_clicks' => 'hs_social_linkedin_clicks_c',
    'hs_social_num_broadcast_clicks' => 'hs_social_num_broadcast_clicks_c',
    'hs_social_facebook_clicks' => 'hs_social_facebook_clicks_c',
    'hs_analytics_revenue' => 'hs_analytics_revenue_c',
    'hs_analytics_first_url' => 'hs_analytics_first_url_c',
    'hs_analytics_first_referrer' => 'hs_analytics_first_referrer_c',
    'hs_analytics_num_event_completions' => 'hs_analytics_num_event_completions_c',
    'hs_social_google_plus_clicks' => 'hs_social_google_plus_clicks_c',
    'hs_analytics_last_timestamp' => 'hs_analytics_last_timestamp_c',
    'hs_analytics_num_page_views' => 'hs_analytics_num_page_views_c',
    'hs_analytics_first_timestamp' => 'hs_analytics_first_timestamp_c',
    'num_conversion_events' => 'hs_num_conversion_events_c',
    'hs_analytics_source' => 'hs_analytics_source_c',
    'hs_analytics_source_data_2' => 'hs_analytics_source_data_2_c',
    'hs_analytics_source_data_1' => 'hs_analytics_source_data_1_c',
    'hs_analytics_num_visits' => 'hs_analytics_num_visits_c',
    'hs_analytics_last_referrer' => 'hs_analytics_last_referrer_c',
    'hs_analytics_last_url' => 'hs_analytics_last_url_c',
    'hs_social_last_engagement' => 'hs_social_last_engagement_c',
    'hs_social_twitter_clicks' => 'hs_social_twitter_clicks_c',
    'num_unique_conversion_events' => 'hs_num_unique_conversion_events_c',
    'hs_analytics_average_page_views' => 'hs_analytics_average_page_views_c',
    'photo' => 'hs_photo_c',
    'followercount' => 'hs_followercount_c',
    'twitterbio' => 'hs_twitterbio_c',
    'twitterprofilephoto' => 'hs_twitterprofilephoto_c',
    'hs_analytics_first_visit_timestamp' => 'hs_analytics_first_visit_timestamp_c',
    'first_conversion_event_name' => 'hs_first_conversion_event_name_c',
    'recent_conversion_event_name' => 'hs_recent_conversion_event_name_c',
    'first_conversion_date' => 'hs_first_conversion_date_c',
    'ip_city' => 'hs_ip_city_c',
    'ip_state' => 'hs_ip_state_c',
    'ip_country' => 'hs_ip_country_c',
    'ip_latlon' => 'hs_ip_latlon_c',
    'recent_conversion_date' => 'hs_recent_conversion_date_c',
);

$hubspot_1crm_cstm = array(
    'LEAD_GUID' => 'hs_guid_c',
    'vid' => 'hs_vid_c',
    'portal-id' => 'hs_portal_id_c',
    'createdate' => 'hs_createdate_c', //date
    'lastmodifieddate' => 'hs_lastmodifieddate_c', //date
    //'lifecyclestage'     => 'hs_lifecyclestage_c', //dropdown - hs_lifecyclestage_list
    'ipaddress' => 'hs_ipaddress_c',
    // 'company'             => 'hs_company_c',
    'company' => 'account_name',
    'website' => 'hs_website_c',
    'jobtitle' => 'title',
    'annualrevenue' => 'hs_annualrevenue_c',
    'numemployees' => 'hs_numemployees_c',

    'twitterhandle' => 'hs_twitterhandle_c',
    'kloutscoregeneral' => 'hs_kloutscoregeneral_c',
    'hs_social_linkedin_clicks' => 'hs_social_linkedin_clicks_c',
    'hs_social_num_broadcast_clicks' => 'hs_social_num_broadcast_clicks_c',
    'hs_social_facebook_clicks' => 'hs_social_facebook_clicks_c',
    'hs_analytics_revenue' => 'hs_analytics_revenue_c',
    'hs_analytics_first_url' => 'hs_analytics_first_url_c',
    'hs_analytics_first_referrer' => 'hs_analytics_first_referrer_c',
    'hs_analytics_num_event_completions' => 'hs_analytics_num_event_completions_c',
    'hs_social_google_plus_clicks' => 'hs_social_google_plus_clicks_c',
    'hs_analytics_last_timestamp' => 'hs_analytics_last_timestamp_c',
    'hs_analytics_num_page_views' => 'hs_analytics_num_page_views_c',
    'hs_analytics_first_timestamp' => 'hs_analytics_first_timestamp_c',
    'num_conversion_events' => 'hs_num_conversion_events_c',
    'hs_analytics_source' => 'hs_analytics_source_c',
    'hs_analytics_source_data_2' => 'hs_analytics_source_data_2_c',
    'hs_analytics_source_data_1' => 'hs_analytics_source_data_1_c',
    'hs_analytics_num_visits' => 'hs_analytics_num_visits_c',
    'hs_analytics_last_referrer' => 'hs_analytics_last_referrer_c',
    'hs_analytics_last_url' => 'hs_analytics_last_url_c',
    'hs_social_last_engagement' => 'hs_social_last_engagement_c',
    'hs_social_twitter_clicks' => 'hs_social_twitter_clicks_c',
    'num_unique_conversion_events' => 'hs_num_unique_conversion_events_c',
    'hs_analytics_average_page_views' => 'hs_analytics_average_page_views_c',
    'photo' => 'hs_photo_c',
    'followercount' => 'hs_followercount_c',
    'twitterbio' => 'hs_twitterbio_c',
    'twitterprofilephoto' => 'hs_twitterprofilephoto_c',
    'hs_analytics_first_visit_timestamp' => 'hs_analytics_first_visit_timestamp_c',
    'first_conversion_event_name' => 'hs_first_conversion_event_name_c',
    'recent_conversion_event_name' => 'hs_recent_conversion_event_name_c',
    'first_conversion_date' => 'hs_first_conversion_date_c',
    'ip_city' => 'hs_ip_city_c',
    'ip_state' => 'hs_ip_state_c',
    'ip_country' => 'hs_ip_country_c',
    'ip_latlon' => 'hs_ip_latlon_c',
    'recent_conversion_date' => 'hs_recent_conversion_date_c',
);

$hubspot_1crm_exclude = array();

$hs_lifecyclestage_arr = array(
    'subscriber' => array(
        'order' => '1',
        'prev' => '',
        'crm' => 'Prospects',
    ),
    'lead' => array(
        'order' => '2',
        'prev' => 'subscriber',
        'crm' => 'Leads',
    ),
    'marketingqualifiedlead' => array(
        'order' => '2',
        'prev' => 'subscriber',
        'crm' => 'Leads',
    ),
    'salesqualifiedlead' => array(
        'order' => '2',
        'prev' => 'subscriber',
        'crm' => 'Leads',
    ),
    'opportunity' => array(
        'order' => '3',
        'prev' => 'lead',
        'crm' => 'Accounts',
    ),
    'customer' => array(
        'order' => '3',
        'prev' => 'lead',
        'crm' => 'Accounts',
    ),
    // 'evangelist'
    // 'other'
);

$hubspot_1crm_amend = array( // edit array for accounts
    // 'firstname'       => 'name',
    // 'lastname'        => 'name',
    'company' => 'name',
    'phone' => 'phone_alternate',
    'address' => 'primary_address_street',
    'city' => 'primary_address_city',
    'state' => 'primary_address_state',
    'zip' => 'primary_address_postalcode',
    'country' => 'primary_address_country',
);

$read_only_hs_arr = array(
    'LEAD_GUID',
    'vid',
    'portal-id',
    'createdate',
    'lastmodifieddate',
    'ipaddress',
    'hs_analytics_num_visits',
    'hs_social_linkedin_clicks',
    'hs_social_num_broadcast_clicks',
    'hs_social_facebook_clicks',
    'hs_analytics_revenue',
    'hs_social_twitter_clicks',
    'num_unique_conversion_events',
    'hs_analytics_num_event_completions',
    'hs_social_google_plus_clicks',
    'hs_analytics_num_page_views',
    'num_conversion_events',
    'hs_analytics_source',
    'hs_analytics_first_timestamp',
    'hs_analytics_source_data_2',
    'hs_analytics_source_data_1',
    'hs_analytics_average_page_views',
    'hs_closed_amount',
);

$hubspot_1crm_acc = array(
    'name' => 'name',
    'phone' => 'phone_office',
    'address' => 'primary_address_street',
    'city' => 'primary_address_city',
    'state' => 'primary_address_state',
    'zip' => 'primary_address_postalcode',
    'country' => 'primary_address_country',
);

$hsSStoCRMStage[]['contractsent'] = "Negotiation/Review";
$hsSStoCRMStage[]['appointmentscheduled'] = "Prospecting";
$hsSStoCRMStage[]['presentationscheduled'] = "Value Proposition";
$hsSStoCRMStage[]['decisionmakerboughtin'] = "Id. Decision Makers";

$hsSStoCRMStage[]['qualifiedtobuy'] = "Needs Analysis";

$hsSStoCRMStage[]['closedwon'] = "Closed Won";
$hsSStoCRMStage[]['closedlost'] = "Closed Lost";
$hsSStoCRMStage[]['qualifiedtobuy'] = "Proposal/Price Quote";


$hs1CRMOpp ['dealname'] = "name";
$hs1CRMOpp ['closedate'] = "date_closed";
$hs1CRMOpp ['amount'] = "amount";
$hs1CRMOpp ['dealstage'] = "sales_stage";
$hs1CRMOpp ['vid'] = "hs_dealid_c";


$hsNoteFields ['vid'] = "hs_vid_c";
$hsNoteFields ['body'] = "description";

$hsTaskFields ['vid'] = "hs_vid_c";
$hsTaskFields ['body'] = "description";
$hsTaskFields ['subject'] = "name";
$hsTaskFields ['status'] = "status";
$hsTaskFields ['forObjectType'] = "CONTACT";

$hsMeetingFields ['vid'] = "hs_vid_c";
$hsMeetingFields ['body'] = "description";
$hsMeetingFields ['title'] = "name";
$hsMeetingFields ['status'] = "status";
$hsMeetingFields ['forObjectType'] = "CONTACT";

$hsCallFields ['vid'] = "hs_vid_c";
$hsCallFields ['body'] = "description";
$hsCallFields ['title'] = "name";
$hsCallFields ['status'] = "status";
$hsCallFields ['forObjectType'] = "CONTACT";

$hsEmailFields ['vid'] = "hs_vid_c";
$hsEmailFields ['body'] = "description";
$hsEmailFields ['title'] = "name";
$hsEmailFields ['status'] = "status";
$hsEmailFields ['forObjectType'] = "CONTACT";

$hsNoteFields ['vid'] = "hs_vid_c";
$hsNoteFields ['body'] = "description";
#$hsNoteFields ['title'] = "name";
#$hsNoteFields ['status'] = "status";
#$hsNoteFields ['forObjectType'] = "CONTACT";

$dateFields['closedate'] = 1;


//$dropDownFlds['dealstage'] = $hsSStoCRMStage;

/**
 * Class dmcHSSync
 *
 * @category SugarCRM
 * @package  DanmarCRM_Hubspot
 * @author   DanmarCRM <dan@danmarcrm.com>
 * @license  DanmarCRM https://DanmarCRM.com/licence.php
 * @link     https://DanmarCRM.com
 * @comment  danmar
 * @return   void
 */
class dmcHSSync
{
    var $crmModule = "";
    var $action = "";
    var $crmOb; //crm object
    var $hsID; //hs id
    var $table_name;
    var $table_name_cstm;
    var $hs_vid_c = "hs_vid_c"; // id field name in _cstm table
    var $hsLeadFields = array();
    var $hsLeadFieldsCstm = array();
    var $hsOb;  // hubspot values/object
    var $userID = 1;
    var $hsAcctURL = 'https://api.hubapi.com/companies/v2/companies/';
    var $hsCtURL = 'https://api.hubapi.com/contacts/v1/contact/vid/';
    var $hsDealURL = 'https://api.hubapi.com/deals/v1/deal/';
    var $hsAssocURL = 'https://api.hubapi.com/crm-associations/v1/associations/';
    var $hsPropURL = 'https://api.hubapi.com/crm/v3/properties/objtype?archived=false';
    var $hsAssocGetCtsFromAct = 2;
    var $dateFields;
    var $lnkCt;
    var $lnkCtHS;
    var $lnkCtHS2;
    var $lnkOpp;
    var $hsTaskFields;
    var $hsMeetingFields;
    var $hsCallFields;
    var $hsEmailFields;
    var $hsNoteFields;
    var $lnkAct;
    var $actName;
    var $modFlds;
    var $modFldsCstm;
    var $existingLead;
    var $hsProp = array();
    var $read_only_hs_arr;
    var $parentAction = "";
    var $subscriptionType = "";
    var $mode = "";
    var $hs_time_c;
    var $occurredAt;
    var $appID = "190023";
    var $dropDownFlds = array();
    var $hubspot_sugarcrm_ownermap = array();
    var $fields1CRM = array();

    /**
     * HS Helper
     *
     * @return void
     */
    function __construct($action)
    {
        global $hubspot_1crm;
        global $hubspot_1crm_cstm;
        global $hubspot_1crm_acc, $hsSStoCRMStage, $hs1CRMOpp,$hsNoteFields,$hsTaskFields,$hsMeetingFields,$hsCallFields,$hsEmailFields,$hsNoteFields, $dateFields, $read_only_hs_arr;
        global $dropDownFlds;
        if (!$this->ckEnabled()) {
            return false;
        }
        //print_r($hs1CRMOpp);
        $this->action = $action;
        $this->getCRMObject();
        $this->hsLeadFields = $hubspot_1crm;
        $this->hsLeadFieldsCstm = $hubspot_1crm_cstm;
        $this->hsAccountFields = $hubspot_1crm_acc;
        $this->sStageMap = $hsSStoCRMStage;
        $this->hsOpportunityFields = $hs1CRMOpp;
        $this->hsTaskFields = $hsTaskFields;
        $this->hsMeetingFields = $hsMeetingFields;
        $this->hsCallFields = $hsCallFields;
        $this->hsEmailFields = $hsEmailFields;
        $this->hsNoteFields = $hsNoteFields;
        $this->read_only_hs_arr = $read_only_hs_arr;
        $this->dateFields = $dateFields;
        $this->dropDownFlds = $dropDownFlds;
        $this->loadCustomMapping();
        
            if (class_exists("dmcHSCustom")){
                dmcHSCustom::ckCreateRecord($this);    
            }
    }

    /**
     * Check if the integration is enabled
     *
     * @return bool
     */
    function ckEnabled()
    {
        global $db;
        $sq = "select * from config where category='dmc_hs_keys' and name='hsDmcStatus'";
        $r = $db->query($sq);
        $row = $db->fetchByAssoc($r);
        if ($row['value'] == 'connected') {
            lg("ckEnabled true");
            return true;
        } else {
            lg("ckEnabled false");
            return false;
        }
    }

    /**
     * Get custom mapping if configured
     *
     * @return void
     */
    function loadCustomMapping()
    {
        global $db;
        lg("loadCustomMapping");
        $sq = "SELECT * FROM config WHERE  name='json_crm_hubspot' ";
        $r = $db->query($sq);
        $row = $db->fetchByAssoc($r);
        $content = str_replace('&quot;', '"', $row['value']);
        if (isset($content) && $content) {
            $obj = json_decode($content, true);
            $array = (array)$obj;
        } else {
            $array = [];
        }
        $output = $array;
        if (count($output) > 0) {
            if (count($output['accounts_companies']) > 0) {
                $this->hsAccountFields = array_flip($output['accounts_companies']);
            }
            if (count($output['contacts_contacts']) > 0) {
                $this->hsLeadFields = array_flip($output['contacts_contacts']);
            }
            if (count($output['opportunities_deals']) > 0) {
                $this->hsOpportunityFields = array_flip($output['opportunities_deals']);
            }
            //print_r($output);
            //exit(); 
        }
            unset($this->hsAccountFields['id']);
            unset($this->hsAccountFields['id_c']);
            unset($this->hsLeadFields['id']);
            unset($this->hsLeadFields['id_c']);
            unset($this->hsOpportunityFields['id']);
            unset($this->hsOpportunityFields['id_c']);
            
        $appLng = return_app_list_strings_language("en_us");
        lg("loadCustomMapping return_app_list_strings_language:");
        //lg($appLng);
        if (isset($appLng['hubspot_sugarcrm_ownermap'])){
            $this->hubspot_sugarcrm_ownermap = $appLng['hubspot_sugarcrm_ownermap'];
            lg("hubspot_sugarcrm_ownermap s2:".print_r($this->hubspot_sugarcrm_ownermap,true));    
        }
        
    }

    /**
     * Get HS Account url
     *
     * @return string
     */
    function getHSAcctLink($id)
    {
        $url = $this->hsAcctURL . $id;
        return $url;
    }
    
    /**
     * Get Campaign SQL
     *
     * @return string
     */
    function getCampaignSQL($id)
    {
        $sq = "select * from campaigns where id = '{$id}'";
        return $sq;
    }    
    
    /**
     * Get Campaign SQL
     *
     * @return string
     */
    function getCampaignByNameSQL($name)
    {
        $sq = "select * from campaigns where name = '{$name}' and deleted = 0";
        return $sq;
    }    
    
    /**
     * Get Campaign by ID
     *
     * @return string
     */
    function getCampaignByID($id)
    {
        global $db;
        lg("getCampaignByID");
        $sq = $this->getCampaignSQL($id);
        $r = $db->query($sq);
        $row = $db->fetchByAssoc($r);
        return $row;
    }    
    
    /**
     * Get Campaign by ID
     *
     * @return string
     */
    function getCampaignByName($name)
    {
        global $db;
        lg("getCampaignByName: ".$name);
        $sq = $this->getCampaignByNameSQL($name);
        $r = $db->query($sq);
        $row = $db->fetchByAssoc($r);
        return $row;
    }

    /**
     * Get HS Contact url
     *
     * @return string
     */
    function getHSCtLink($id)
    {
        $url = $this->hsCtURL . $id . "/profile";
        return $url;
    }

    /**
     * Get HS Deal url
     *
     * @return string
     */
    function getHSDealLink($id)
    {
        $url = $this->hsDealURL . $id;
        return $url;
    }

    /**
     * Get HS Related url
     *
     * @return string
     */
    function getHSAssocURL($id, $relID)
    {
        $url = $this->hsAssocURL . $id . "/HUBSPOT_DEFINED/" . $relID;
        return $url;
    }

    /**
     * Get CRM Object
     *
     * @return void
     */
    function getCRMObject()
    {
        lg("getCRMObject");
        file_put_contents("__ddbgHS.log","\n getCRMObject: ".$this->action,FILE_APPEND);
        if ($this->action == "newLead" or $this->action == "updLead") {
            $this->crmModule = "Lead";
            file_put_contents("__ddbgHS.log","\n crmModule: ".$this->crmModule,FILE_APPEND);
        }
        if ($this->action == "newDeal" or $this->action == "updDeal") {
            $this->crmModule = "Opportunity";
        }
        if ($this->action == "newContact" or $this->action == "updContact") {
            $this->crmModule = "Contact";
        }
        if ($this->action == "newAccount" or $this->action == "updAccount" or $this->action == "newCompany") {
            $this->crmModule = "Account";
        }
        if ($this->action == "newTask" or $this->action == "updTask") {
            $this->crmModule = "Task";
        }
        if ($this->action == "newMeeting" or $this->action == "updMeeting") {
            $this->crmModule = "Meeting";
        }
        if ($this->action == "newCall" or $this->action == "updCall") {
            $this->crmModule = "Call";
        }
        if ($this->action == "newEmail" or $this->action == "updEmail") {
            $this->crmModule = "Email";
        }
        if ($this->action == "newNote" or $this->action == "updNote") {
            $this->crmModule = "Note";
        }

        
        $this->crmOb = RowUpdate::blank_for_model($this->crmModule);
        //$dbg = debug_backtrace(2);
        //file_put_contents("__ddbgHS.log","\n ".print_r($dbg,true),FILE_APPEND);
        file_put_contents("__ddbgHS.log","\n tbl: ".print_r($this->crmOb,true),FILE_APPEND);
        file_put_contents("__ddbgHS.log","\n tbl: ".$this->crmOb->table_name,FILE_APPEND);
        //ob_flush();
        //print_r($dbg);
        
        //exit();
        $this->table_name = $this->crmOb->table_name;
        $this->table_name_cstm = $this->crmOb->table_name . "_cstm";
        //file_put_contents("__ddbgHSFieldDefs.log","\n tbl a: ",FILE_APPEND);
        //print_r($this->crmOb->fields);
        //exit();
        if (!isset($this->crmOb->table_name) and isset($this->crmOb->model) and isset($this->crmOb->model->table_name) ){
        	file_put_contents("__ddbgHSFieldDefs.log","\n tbl: ",FILE_APPEND);
			$this->table_name = $this->crmOb->model->table_name;
			$this->table_name_cstm = $this->crmOb->model->table_name . "_cstm";
			$this->crmOb->field_defs = $this->crmOb->fields;	
			//print_r($this->crmOb->field_defs);
			//exit();
			//file_put_contents("__ddbgHSFieldDefs.log","\n tbl: ".print_r($this->crmOb->field_defs,true),FILE_APPEND);
			
        }        
        
        lg("getCRMObject: " . $this->crmModule);
        /*echo "<br>TBLN:".$this->table_name."
        Action: ".$this->action." Module: ".$this->crmModule;*/

    }

    /**
     * Get HS CRM Fields Definition
     *
     * @return void
     */
    function loadFieldsMetaData()
    {
        lg("loadFieldsMetaData module: ".$this->crmModule);
        //echo "<br>flds";
        //$d = debug_backtrace(2);
        //print_r($d);
        if ($this->crmModule == "Lead" or $this->crmModule == "Contact") {
            lg("hsLeadFields: ".print_r($this->hsLeadFields,true));
            lg("hsLeadFieldscstm: ".print_r($this->hsLeadFieldsCstm,true));
            $this->modFlds = $this->hsLeadFields;
            $this->modFldsCstm = $this->hsLeadFieldsCstm;
        }
        if ($this->crmModule == "Opportunity") {
            $this->modFlds = $this->hsOpportunityFields;                     
            $this->modFldsCstm = array();
        }
        if ($this->crmModule == "Account") {
            $this->modFlds = $this->hsAccountFields;
            $this->modFldsCstm = array();
        }
        if ($this->crmModule == "Task") {
            $this->modFlds = $this->hsTaskFields;
            $this->modFldsCstm = array();
        }
        if ($this->crmModule == "Meeting") {
            $this->modFlds = $this->hsMeetingFields;
            $this->modFldsCstm = array();
        }
        if ($this->crmModule == "Call") {
            $this->modFlds = $this->hsCallFields;
            $this->modFldsCstm = array();
        }
        if ($this->crmModule == "Email") {
            $this->modFlds = $this->hsEmailFields;
            $this->modFldsCstm = array();
        }
        if ($this->crmModule == "Note") {
            $this->modFlds = $this->hsNoteFields;
            $this->modFldsCstm = array();
        }
    }

    /**
     * Get Populate HS Values
     *
     * @return void
     */
    function putHSValues($hsPropName = 'name')
    {
        lg("putHSValues:");
        $this->loadFieldsMetaData();
        if ($this->crmModule == "Account") {

        }
        $totFlds = array_merge($this->modFlds, $this->modFldsCstm);
        lg("putHSValues fields: ".print_r($totFlds,true));
        foreach ($totFlds as $k => $v) {
            $hsFldName = $k;
            $crmFldName = $v;
            if (isset($this->dropDownFlds[$hsFldName])) {
                $crmFldVal = $this->getCRMDropDownVal($crmFldName, $this->dropDownFlds[$hsFldName]);
                //echo "\n found: ".$crmFldVal;
            } else {
                $crmFldVal = $this->getCRMVal($crmFldName);
            }
            //echo "<br>\n f: ".$crmFldName;
            $crmFldVal = $this->putDateTimeBool($crmFldName,$crmFldVal); 
            //lg("Putfield fields: ".$hsFldName." v: ".$crmFldVal." hsp: ".$hsPropName);
            if (!is_object($hsFldName) and !is_array($hsFldName) and !is_object($crmFldVal) and !is_array($crmFldVal) and !is_object($hsPropName) and !is_array($hsPropName)){
                $this->putHSPropVal($hsFldName, $crmFldVal, $hsPropName);
            }else{
                lg("found object or array: ");      
                lg($hsFldName);      
                lg($crmFldVal);      
                lg($hsPropName);      
            }
            //echo "<br>\n Putfield : ".$hsFldName." v: ".$crmFldVal." hsp: ".$hsPropName;
        }
        lg("count :".count($this->hubspot_sugarcrm_ownermap));
        if (count($this->hubspot_sugarcrm_ownermap) > 0){
            $crmAssignedID = $this->getCRMVal("assigned_user_id");
            lg("assigned: ".$crmAssignedID);    
            $userName = $this->getUserNamebyID($crmAssignedID);
            lg("username: ".$userName);    
            if ($userName != ""){
                lg("u2 : ".print_r($this->hubspot_sugarcrm_ownermap,true));    
                if (isset($this->hubspot_sugarcrm_ownermap[$userName])){
                    $foundHSOwner = $this->hubspot_sugarcrm_ownermap[$userName];
                    lg("found: ".$foundHSOwner." hsprop: ".$hsPropName);    
                    $this->putHSPropVal("hubspot_owner_id", $foundHSOwner, $hsPropName);  
                    //hubspot_owner_id    
                }
            }
        }
    }
    
    function getSugarRowByID($tblName,$id){
        global $db;
        $sq = "select * from {$tblName} left join {$tblName}_cstm on id = id_c where deleted = 0 and id = '{$id}'";
        $r = $db->query($sq);
        $row = $db->fetchByAssoc($r);   
        return $row;       
    }
    
    /**
     * Get Populate HS Values
     *
     * @return void
     */
    function putHSValuesEng($hsPropName = 'name')
    {
        lg("putHSValues:");
        $this->loadFieldsMetaData();
        if ($this->crmModule == "Account") {

        }
        $totFlds = array_merge($this->modFlds, $this->modFldsCstm);
        lg("putHSValues fields: ".print_r($totFlds,true));
        foreach ($totFlds as $k => $v) {
            $hsFldName = $k;
            $crmFldName = $v;
            if (isset($this->dropDownFlds[$hsFldName])) {
                $crmFldVal = $this->getCRMDropDownVal($crmFldName, $this->dropDownFlds[$hsFldName]);
                //echo "\n found: ".$crmFldVal;
            } else {
                $crmFldVal = $this->getCRMVal($crmFldName);
            }
            $crmFldVal = $this->putDateTimeBool($crmFldName,$crmFldVal); 
            //lg("Putfield fields: ".$hsFldName." v: ".$crmFldVal." hsp: ".$hsPropName);
            if (!is_object($hsFldName) and !is_array($hsFldName) and !is_object($crmFldVal) and !is_array($crmFldVal) and !is_object($hsPropName) and !is_array($hsPropName)){
                $this->putHSPropValEng($hsFldName, $crmFldVal, $hsPropName);
            }else{
                lg("found object or array: ");      
                lg($hsFldName);      
                lg($crmFldVal);      
                lg($hsPropName);      
            }
            //echo "<br>\n Putfield : ".$hsFldName." v: ".$crmFldVal." hsp: ".$hsPropName;
        }
        lg("count :".count($this->hubspot_sugarcrm_ownermap));
        if (count($this->hubspot_sugarcrm_ownermap) > 0){
            $crmAssignedID = $this->getCRMVal("assigned_user_id");
            lg("assigned: ".$crmAssignedID);    
            $userName = $this->getUserNamebyID($crmAssignedID);
            lg("username: ".$userName);    
            if ($userName != ""){
                lg("u2 : ".print_r($this->hubspot_sugarcrm_ownermap,true));    
                if (isset($this->hubspot_sugarcrm_ownermap[$userName])){
                    $foundHSOwner = $this->hubspot_sugarcrm_ownermap[$userName];
                    lg("found: ".$foundHSOwner." hsprop: ".$hsPropName);    
                    $this->putHSPropValEng("hubspot_owner_id", $foundHSOwner, $hsPropName);  
                    //hubspot_owner_id    
                }
            }
        }
        
        if ($this->crmModule == "Task"){
            $status = $this->crmOb->status;
                if ($status == "Completed" or $status == "Deferred"){
                    $this->putHSPropValEng("status", "COMPLETED", "status");    
                }else{
                    $this->putHSPropValEng("status", "NOT_STARTED", "status");    
                }    
        }        
        if ($this->crmModule == "Meeting"){
            $status = $this->crmOb->status;
                if ($status == "Held" or $status == "Canceled"){
                    $this->putHSPropValEng("status", "COMPLETED", "status");    
                }else{
                    $this->putHSPropValEng("status", "NOT_STARTED", "status");    
                }    
        }        
        if ($this->crmModule == "Call"){
            $status = $this->crmOb->status;
                if ($status == "Held" or $status == "Canceled"){
                    $this->putHSPropValEng("status", "COMPLETED", "status");    
                }else{
                    $this->putHSPropValEng("status", "NOT_STARTED", "status");    
                    $this->putHSPropValEng("status", "COMPLETED", "status");    
                }    
        }        
        if ($this->crmModule == "Email"){
            $status = $this->crmOb->status;
                if ($status == "Held" or $status == "Canceled"){
                    $this->putHSPropValEng("status", "COMPLETED", "status");    
                }else{
                    $this->putHSPropValEng("status", "NOT_STARTED", "status");    
                    $this->putHSPropValEng("status", "COMPLETED", "status");    
                }    
        }        
        if ($this->crmModule == "Note"){
            $status = $this->crmOb->status;
/*                if ($status == "Held" or $status == "Canceled"){
                    $this->putHSPropValEng("status", "COMPLETED", "status");    
                }else{
                    $this->putHSPropValEng("status", "NOT_STARTED", "status");    
                    $this->putHSPropValEng("status", "COMPLETED", "status");    
                }*/    
        }
    }
    
    function putDateTimeBool($crmFldName,$crmFldVal){
        
        $flds = $this->crmOb->field_defs;
        
        //$dbType = $this->crmOb->getFieldDbType($crmFldName);
        //print_r($this->crmOb);
        if (count($this->fields1CRM) == 0){
        	$crmModule = $this->crmOb->object_name;
        	echo "<br>\n cccccccccccccc: ".$crmModule;
			$bean = RowUpdate::blank_for_model($crmModule);
			$this->fields1CRM = $bean->fields;
			$this->crmOb->field_defs = $this->fields1CRM;
			//print_r($this->crmOb->field_defs);	
        }
        //$flds[$crmFldName]['type'] = $dbType;
        
        //exit();
        //echo "<br><br><br>\n";
        //print_r($this->crmOb->field_defs);
        //$dbg = debug_backtrace(2);
        //print_r($dbg);
        //exit();
        //exit();
        //echo "<br>\n f: ".$crmFldName." crmf: ".print_r($flds[$crmFldName]);
        $crmFldValOrig = $crmFldVal;
        global $db;

/*                	if ($crmFldName == "date_closed"){
                		echo "<br>\n type: ".$flds[$crmFldName]['type'];
                		echo "<br>\n type: ".print_r($flds[$crmFldName]);
                		exit();
					}*/
        echo "<br>\n fld: ".$flds[$crmFldName]['type'];
        if (isset($flds[$crmFldName]) and isset($flds[$crmFldName]['type']) or $crmFldName == "date_closed"){
            if ($flds[$crmFldName]['type'] == "date" or $flds[$crmFldName]['type'] == "datetimecombo" or $flds[$crmFldName]['type'] == "datetime" or $crmFldName == "date_closed"){
                if ($crmFldVal == ""){
                    return "";    
                }
                try {

                if ($flds[$crmFldName]['type'] == "datetimecombo" or $flds[$crmFldName]['type'] == "datetime"){
                    //$date = new DateTime($crmFldVal);
                    $date = new DateTimeImmutable($crmFldVal);
                    $crmFldVal = $date->format('Y-m-d');
                }
                //$date1 = strtotime($crmFldVal) * 1000; 
                //$interval = new DateInterval('PT72H30M45S');    
                $dateIm = new DateTimeImmutable($crmFldVal);
                $offset = $dateIm->getOffset();
                //$dateIm->sub($interval);
                //$crmFldVal2 = $dateIm->format('Y-m-d H:i:s');  
                $sqCkLogLevel = "SELECT * FROM config WHERE  name='hsDateOffset' and category = 'dmc_hs_keys'";
                $rCk = $db->query($sqCkLogLevel);
                $rowCk = $db->fetchByAssoc($rCk);  
                if ($rowCk['value'] != ""){
                    $offSetDB = $rowCk['value'];    
                }else{
                    $offSetDB = 0;
                }              
                $date1 = ($dateIm->getTimestamp() - $offSetDB) * 1000;
                lg("date: ".$date1." val: ".$crmFldVal." fld: ".$crmFldName." val2: ".$crmFldVal2." orig: ".$crmFldValOrig." offset: ".$offset);
                }catch (exception $e) {
                    lg("Error Date: ".$e->getMessage()); 
                }
                return $date1;              
            }
            
            if ($flds[$crmFldName]['type'] == "bool" or $crmFldName == "email_opt_out" or $crmFldName == "email_opt_in"){
            	echo "<br>\n email_opt_out: ".$crmFldName." v: ".$crmFldVal;
                if ($crmFldVal == 1) return "true";    
                if ($crmFldVal == 0) return "false";    
            }    
        }else{
			if ($flds[$crmFldName]['type'] == "bool" or $crmFldName == "email_opt_out" or $crmFldName == "email_opt_in"){
            	//echo "<br>\n email_opt_out: ".$crmFldName." v: ".$crmFldVal;
                if ($crmFldVal == 1) return "true";    
                if ($crmFldVal == 0) return "false";    
            }
        }
        
/*        if ($crmFldName == "email_opt_out"){
			
			if ($crmFldVal == "1"){
				return "true";	
			}
			if ($crmFldVal == "1"){
				return "false";	
			}	
        }
        if ($crmFldName == "email_opt_in"){
			if ($crmFldVal == "1"){
				return "true";	
			}
			if ($crmFldVal == "1"){
				return "false";	
			}	
        }*/
        return $crmFldVal;
        
    }
        
    function putDateTimeBoolHSVal($crmFldName,$hsFldVal){
        
        $flds = $this->crmOb->field_defs;
        if (isset($flds[$crmFldName]) and isset($flds[$crmFldName]['type'])){
            if ($flds[$crmFldName]['type'] == "date" or $flds[$crmFldName]['type'] == "datetimecombo" or $flds[$crmFldName]['type'] == "datetime"){  
                //$date1 = strtotime($crmFldVal) * 1000;  
                if ($hsFldVal != ""){
                $hsFldVal = $hsFldVal/1000;  
                $date = date("Y-m-d H:i:s",$hsFldVal);
                    if ($flds[$crmFldName]['type'] == "date" or $flds[$crmFldName]['type'] == "date"){
                        $date2 = new DateTime($date);
                        $date = $date2->format('Y-m-d');
                    }                
                return $date;            
                }   
            }
            if ($flds[$crmFldName]['type'] == "bool"){
                //return (bool)$hsFldVal;
                if ($hsFldVal == 'false' or $hsFldVal == "'false'") return false;   // we receive the value escaped  
                if ($hsFldVal == 'true' or $hsFldVal == "'true'") return true;    
                //if ($hsFldVal === false) return false;    
            }    
        }
        return $hsFldVal;
        
    }

    /**
     * get UserNameby ID
     *
     * @return bool
     */
    function getUserNamebyID($id)
    {
        global $db;
        $sq = "select * from users where id = '{$id}'";
        $r = $db->query($sq);
        $row = $db->fetchByAssoc($r);
        return $row['user_name'];
        
    }
    /**
     * get UserNameby ID
     *
     * @return bool
     */
    function getUserIDbyUserName($user_name)
    {
        global $db;
        $sq = "select * from users where user_name = '{$user_name}' and deleted = 0";
        $r = $db->query($sq);
        $row = $db->fetchByAssoc($r);
        return $row['id'];
        
    }
    /**
     * Check if the field is readonly
     *
     * @return bool
     */
    function ckReadOnlyInHS($hsFldName)
    {
        if (class_exists("dmcHSCustom")){ 
            if (method_exists("dmcHSCustom","cstmCkReadOnlyInHS")){
                $ckCustom = dmcHSCustom::cstmCkReadOnlyInHS($hsFldName);   
                if ($ckCustom){
                    return true;
                }  
            } 
        }        
        foreach ($this->read_only_hs_arr as $k => $v) {
            if ($v == $hsFldName) {
                return true;
            }
        }
        return false;
    }

    /**
     * Convert HS Datetime
     *
     * @return time
     */
    function getHSDate($val)
    {
        return strtotime($val) * 1000;
    }

    /**
     * Populate HS
     *
     * @return void
     */
    function putHSPropVal($hsFldName, $val, $hsPropName)
    {
        lg("putHSPropVal");
        if ($this->ckReadOnlyInHS($hsFldName)) { // don't put readonly values
            return false;
        }
        if ($val == "") {
            return false;
        }
/*        if (isset($this->dateFields[$hsFldName])) {
            $val = $this->getHSDate($val);
        }*/     
        $prop = array(
            $hsPropName => $hsFldName,
            'value' => $val,
        );
        $this->hsProp[] = $prop;
    }
    
    /**
     * Populate HS
     *
     * @return void
     */
    function putHSPropValEng($hsFldName, $val, $hsPropName)
    {
        lg("putHSPropVal");
        if ($this->ckReadOnlyInHS($hsFldName)) { // don't put readonly values
            return false;
        }
        if ($val == "") {
            return false;
        }
        if (isset($this->dateFields[$hsFldName])) {
            $val = $this->getHSDate($val);
        }
        $prop = array(
            $hsPropName => $hsFldName,
            'value' => $val,
        );
        //$this->hsProp[] = $prop;
        $this->hsProp[$hsFldName] = $val;
    }

    /**
     * Get deal Stage
     *
     * @return string
     */
    function getDealStage($val)
    {
        foreach ($this->sStageMap as $k => $v) {
            if (isset($v[$val])) { // !! TODO double check
                return $v[$val];
            }
        }
    }

    /**
     * Get CRM Value
     *
     * @return string
     */
    function getCRMVal($fldName)
    {
        if (method_exists($this->crmOb, "getField")) {
            return $this->crmOb->getField($fldName);
        } else {
            return $this->crmOb->{$fldName};
        }
    }

    /**
     * Get Dropdown Value
     *
     * @return string
     */
    function getCRMDropDownVal($fldName, $valArray)
    {
        if (method_exists($this->crmOb, "getField")) {
            $val = $this->crmOb->getField($fldName);
        } else {
            $val = $this->crmOb->{$fldName};
        }

        foreach ($valArray as $k => $v) {
            $v = array_flip($v);
            if (isset($v[$val])) {
                return $v[$val];
            }
        }
    }

    /**
     * Get Dropdown Value
     *
     * @return string
     */
    function getDropDownVal($fldName, $valArray)
    {
        foreach ($valArray as $k => $v) {
            //$v = array_flip($v);
            if (isset($v[$fldName])) {
                lg("getDropDownVal: " . $v[$fldName]);
                return $v[$fldName];
            }
        }
    }

    /**
     * Put CRM Values
     *
     * @return string
     */
    function putCrmValues()
    {
        lg("in function putCrmValues mod: " . $this->crmModule);
        $this->putRequiredFields();
        $this->loadFieldsMetaData();

        //if ($this->crmModule == "Contact") {
            if ($this->getCRMVal("id") != ""){
                if (class_exists("dmcHSCustom")){
                    dmcHSCustom::protectFields($this);   
                }                
            }       
        //}
        
        //lg($this->modFlds); 
        foreach ($this->modFlds as $k => $v) {
            $hsFldName = $k;
            $crmFldName = $v;
            $hsFldVal = $this->getHsVal($hsFldName);
            $hsFldVal = $this->putDateTimeBoolHSVal($crmFld,$hsFldVal); // check for date and date time
            $this->crmOb->set($crmFldName, $hsFldVal);           
            lg("set field: ".$crmFldName." val: ".$hsFldVal." hsfldname: ".$hsFldName);      
        }
        foreach ($this->modFldsCstm as $k => $v) {
            $hsFldName = $k;
            $crmFldName = $v;
            $hsFldVal = $this->getHsVal($hsFldName);
            $hsFldVal = $this->putDateTimeBoolHSVal($crmFld,$hsFldVal); // check for date and date time
            $this->crmOb->set($crmFldName, $hsFldVal);
            lg("set field: ".$crmFldName." val: ".$hsFldVal." hsfldname: ".$hsFldName); 
        }
        if ($this->hsID == "") {

        }
        $this->crmOb->set("hs_vid_c", $this->hsID);
        if ($this->crmModule == "Account") {
            /*                if ($this->hsID == "" and $this->hsOb['companyId'] != ""){
                $this->hsID = $this->hsOb['companyId'];
                $this->crmOb->set("hs_vid_c",$this->hsID);   
            }*/
        }

        if ($this->crmModule == "Opportunity") {  // for Opportunities take care of fields as account_id and date_closed
            lg("putCrmValues opp: " . $this->hsOb['dealId'] . " date closed: " . $this->crmOb->getField("date_closed"));
            $this->crmOb->set("hs_dealid_c", $this->hsOb['dealId']);
            $this->handleOppCts();
            $ckAcctId = $this->handleOppAct();
        }
        
        

        if ($this->hs_time_c != "" and $this->hs_time_c != 0) {
            lg("putCrmValues hs_time_c " . $this->hs_time_c);
            $this->crmOb->set("hs_time_c", $this->hs_time_c);
        }
        if (class_exists("dmcHSCustom")){ 
            if (method_exists("dmcHSCustom","cstmPutCRMValues")){
                dmcHSCustom::cstmputCrmValues($this);     
            } 
        }                
                  
        
/*        if ($this->crmModule == "Contact") {
            $campaignID = $this->getCampaignByID($id);
        } */
        //getCampaignByID($id)
        
    }

    /**
     * Check if it is optout
     *
     * @return string
     */
    function ckOptOut()
    {
        $hsFldName = "unsubscribed";
        if ($this->getHsVal($hsFldName) == 1) {
            if (isset($this->crmOb->emailAddress)) {
                foreach ($this->crmOb->emailAddress->addresses as $k => $v) {
                    $this->crmOb->emailAddress->addresses[$k]["opt_out"] = 1;
                }
            }
        }
    }

    /**
     * Check CRM modified Values
     *
     * @return string
     */
    function ckCrmModifiedValues()
    {
        lg("in function ckCrmModifiedValues mod: " . $this->crmModule);
        $this->putRequiredFields();
        $this->loadFieldsMetaData();
        foreach ($this->modFlds as $k => $v) {
            $hsFldName = $k;
            $crmFldName = $v;
            $hsFldVal = $this->getHsVal($hsFldName);
            $crmFldVal = $this->crmOb->getField($crmFldName);
            if ($crmFldVal != $hsFldVal and $hsFldVal != 0) {
                $this->isChanged = true;
                return true;
            }

        }
        foreach ($this->modFldsCstm as $k => $v) {
            $hsFldName = $k;
            $crmFldName = $v;
            $hsFldVal = $this->getHsVal($hsFldName);
            $this->crmOb->set($crmFldName, $hsFldVal);
            $crmFldVal = $this->crmOb->getField($crmFldName);
            if ($crmFldVal != $hsFldVal and $hsFldVal != 0) {
                $this->isChanged = true;
                return true;
            }
        }

    }

    /**
     * Get HS Account url
     *
     * @return string
     */
    function ckCrmFldsCreatedByApp()
    {
        $this->putRequiredFields();
        $this->loadFieldsMetaData();
        lg("ckCrmFldsCreatedByApp ini");
        foreach ($this->modFlds as $k => $v) {
            $hsFldName = $k;
            $crmFldName = $v;
            $createdBy = $this->returnSource($hsFldName, "source-type");
            if ($createdBy == "INTEGRATION") {
                $createdByIntID = $this->returnSource($hsFldName, "source-id");
                if ($createdByIntID == $this->appID) {
                    lg("ckCrmFldsCreatedByApp sid");
                    return true;
                }
            }
            if ($createdBy == "INTEGRATION") {
                $createdByIntID = $this->returnSource($hsFldName, "appId");
                if ($createdByIntID == $this->appID) {
                    lg("ckCrmFldsCreatedByApp appid");
                    return true;
                }
            }
        }
        return false;
    }

    /**
     * Relate Opp Cts
     *
     * @return string
     */
    function handleOppCts()
    {
        lg("handleOppCts");
        if (!isset($this->hsOb)){
            return false;
        }
        if (isset($this->hsOb['associations']) and isset($this->hsOb['associations']['associatedVids'])){
            if (is_array($this->hsOb['associations']['associatedVids'])){
                foreach ($this->hsOb['associations']['associatedVids'] as $k => $v) {
                    $ct = $this->ckRelatedCt($v);
                    lg("\n save opp ct rel: ct id: " . $ct->crmOb->getField("id") . " opp id: " . $this->crmOb->getField("id"));
                    if ($ct->crmOb->getField("id") != "" and $this->crmOb->getField("id") != "") {
                        $this->saveCtOpRel($ct->crmOb->getField("id"), $this->crmOb->getField("id"));         // save in db relationship between ct and opp . If we save opp and triger from putrecords we don't have opp id yet
                    } else {
                        lg("can't save oppct relationship, one of id's is missing");
                    }
                    if ($this->lnkCtHS2 == "" and $ct->crmOb->getField("id") != ""){
                        $this->lnkCtHS2 = $ct->crmOb->getField("id");    
                    }
                }
            }
        }
    }

    /**
     * Check related contact
     *
     * @return string
     */
    function ckRelatedCt($id)
    {
        // Ck related Contact when creating a new Opportunity
        lg("\n in function ckRelatedCt action: " . $this->action);
        $ct = new dmcHSSync("updContact");
        $ct->parentAction = $this->action;
        $ct->checkExsiting($id);
        if ($ct->crmOb->getField("id") == "") {
            $hsCt = $this->getHSContact($id); // get related contact to Opportunity from HS   
            $ct->hsOb = $hsCt;
            $ct->putCrmValues();
            $ct->save();
            $this->lnkCt = $ct->crmOb->getField("id");
            $this->lnkCtHS = $ct->crmOb->getField("hs_vid_c");
            $this->existingLead = $this->checkExistingLead($id);
            if ($this->existingLead != "") { // if there is a lead mark related fields 
                $this->updateLeadField($this->existingLead, "contact_id", $ct->crmOb->getField("id"));
            }
            $this->actName = $ct->crmOb->getField("first_name") . " " . $ct->crmOb->getField("last_name");  // used for new account
            lg("new ct saved: " . $ct->crmOb->getField("id") . " lname: " . $ct->crmOb->getField("last_name"));
            //$this->saveCtopRel($ct->crmOb,$this->crmOb->getField("id"));
            //echo "<br>New Contact Conversion: ".$ct->crmOb->getField("id");

        }
        lg("\n found ct: " . $ct->crmOb->getField("id"));
        return $ct;
    }

    /**
     * Check Related Opp
     *
     * @return string
     */
    function ckRelatedOpp($id)
    {
        // Ck related Opportunity when creating a new  Contact
        lg("in function ckRelatedOpp");
        $op = new dmcHSSync("updDeal");
        $op->parentAction = $this->action;
        $op->checkExsiting($id);
        if ($op->crmOb->getField("id") == "") {
            $hsOpp = $this->getHSDealLink($id); // get related contact to Opportunity from HS   
            $op->hsOb = $hsOpp;
            $op->putCrmValues();
            $op->save();
            lg("new opp saved from ckRelatedOpp: " . $op->crmOb->getField("id") . "<br>\n Action: " . $this->action . " lnkOpplnkOpp " . $this->lnkOpp);

        }
        $this->lnkOpp = $op->crmOb->getField("id");
        return $op;
    }

    /**
     * Update Lead
     *
     * @return string
     */
    function updateLeadField($id, $fldName, $fldValue)
    {
        global $db;
        $fldValue = dmcDbQuote($fldValue);
        $id = dmcDbQuote($id);
        $sq = "update leads set {$fldName} = '{$fldValue}' where id = '{$id}' and deleted = 0";
        $db->query($sq);
    }

    /**
     * Relate Opp To Account
     *
     * @return string
     */
    function handleOppAct()
    {
        lg("handleOppAct function");
        $acctId = $this->getFirstHsCompany();
        lg("<br>\n\n andleOppAct accIDaB: " . $acctId);
        $acc = new dmcHSSync("updAccount");
        $acc->parentAction = $this->action;
        if ($acctId != "") {
            $acc->checkExsiting($acctId);
        }
        lg("handleOppAct accID: " . $acctId);
        // If no account create it
        if ($acc->crmOb->getField("id") == "") {
            $hsAcct = $this->getHSAccount($acctId);
            $acc->hsOb = $hsAcct;
            $acc->putCrmValues();
            if ($acc->crmOb->getField("name") == "") {  // if no account name 
                $this->findNameForAccount($acc);
            }
            $acc->crmOb->set("name", $acc->crmOb->getField("name") . "");
            lg("handleOppAct: " . $acctId);
            $acc->crmOb->set("hs_vid_c", $acctId);
            $_REQUEST['sendToHS'] = true;
            $acc->save();
            $acctId = $acc->crmOb->getField("hs_vid_c");
            $this->linkHSActOpp($this->crmOb->getField("hs_dealid_c"), $acctId);  // link Account to Opp in HS
            // 27082020 TO DO Existing Contact in HS, Create OPP in HS, we create Act in CRM but should be sent back to HS
            //debug_print_backtrace();
            lg("<br>\n savedActToHS: " . $acc->crmOb->hs_vid_c);
            unset($_REQUEST['sendToHS']);
            if ($this->existingLead != "") { // if there is a lead mark related fields 
                $this->updateLeadField($this->existingLead, "account_id", $acc->crmOb->getField("id"));
            }
        }
        $this->crmOb->set("account_id", $acc->crmOb->getField("id"));
        lg("handleOppAct cnthsid: " . $this->lnkCtHS);
        $this->saveCtActRel($this->lnkCt, $acc->crmOb->getField("id"));
        if ($this->lnkCtHS != "" and $acctId != "") {
            $this->linkHSActCt($acctId, $this->lnkCtHS);    // link the account to contact 
        }
        lg("handleOppAct cnthsid step2 : " . $this->lnkCtHS2." act: ".$acc->crmOb->getField("id"));
        if ($this->lnkCtHS2 != "" and $acctId != "") {
            $this->saveCtActRel($this->lnkCtHS2, $acc->crmOb->getField("id"));    // link the account to contact  if not converting lead but attaching deal to contact
        }
        return $acc->crmOb->getField("id");
        //exit(); 
    }

    /**
     * Relate Deal To Company
     *
     * @return string
     */
    function linkHSActOpp($oppHSID, $actHSID)
    {
        $hs = new dmcHSSender();
        $ct = $hs->linkActTO($actHSID, $oppHSID, 6, false);
    }

    /**
     * Relate Company to Contact
     *
     * @return string
     */
    function linkHSActCt($actHSID, $ctHSID)
    {
        $hs = new dmcHSSender();
        $ct = $hs->linkActTO($actHSID, $ctHSID, 2, false);
    }

    /**
     * Account name
     *
     * @return string
     */
    function findNameForAccount($acc)
    {
        $acName = $this->actName . "";
        if ($acName != "") {  // if we created a contact take it's name
            $acc->crmOb->set("name", $acName);
        } else {
            $acc->crmOb->set("name", $this->crmOb->getField("name"));
        }

    }

    /**
     * Populate changes
     *
     * @return string
     */
    function putChangeDB($hsFldName, $hsFldVal,$dbName)
    {
        global $db;
        $extraUpdate = "";
        $isCstm = $newstring = substr($hsFldName, -2); 
        $idFld = "id";
        if ($isCstm == "_c"){
            $dbName = $dbName."_cstm"; 
            $idFld = $idFld."_c";   
        }
        if ($hsFldName == "amount"){
            $extraUpdate = " ,amount_usdollar = '{$hsFldVal}' ";   
        }
        $sq = "update {$dbName} set {$hsFldName} = '{$hsFldVal}' {$extraUpdate} where {$idFld} = '{$this->crmOb->getField("id")}'";  
        $db->query($sq);
    }
    /**
     * Populate changes
     *
     * @return string
     */
    function putChange($hsFldName, $hsFldVal)
    {
        //$this->$this->putRequiredFields();
        lg("putChange hsFldName: " . $hsFldName." val: ".$hsFldVal);
        if (isset($this->dropDownFlds[$hsFldName])) {
            $hsFldVal = $this->getDropDownVal($hsFldVal, $this->dropDownFlds[$hsFldName]);
        }
        if ($hsFldName == "deleted") {
            $crmFld = "deleted";
        } else {
            $this->putRequiredFields();
            $this->loadFieldsMetaData();
                if ($this->getCRMVal("id") != ""){
                    if (class_exists("dmcHSCustom")){
                        dmcHSCustom::protectFields($this);    
                    }                
                }
                lg("modFlds: " . print_r($this->modFlds,true));            
                lg("modFldsCstm: " . print_r($this->modFldsCstm,true));            
            if (isset($this->modFlds[$hsFldName])) {
                $crmFld = $this->modFlds[$hsFldName];
            }
            if (isset($this->modFldsCstm[$hsFldName])) {
                $crmFld = $this->modFldsCstm[$hsFldName];
            }
        }
        if (class_exists("dmcHSCustom")){ 
            if (method_exists("dmcHSCustom","cstmPutChange")){
                $isCstm = dmcHSCustom::cstmPutChange($hsFldName, $hsFldVal,$this);    
                if ($isCstm){
                    return $isCstm;
                } 
            } 
        }        
        
        lg("putChange crmFld: ".$crmFld." val: ".$hsFldVal);  
        if (!isset($crmFld))
            $crmFld = "";
        if ($crmFld != "") {
            $hsFldVal = $this->putDateTimeBoolHSVal($crmFld,$hsFldVal); // check for date and date time
            if ($this->subscriptionType != "deal.propertyChange"){
                lg("crmOb->set1 ");
            $this->crmOb->set($crmFld, $hsFldVal);
            lg("crmOb->set2 ");
            }else{
            $this->putChangeDB($crmFld, $hsFldVal,"opportunities");    
            }
            //if ($crmFld == "amount"){
                //$this->crmOb->set("amount_usdollar", 32);    
                //$this->crmOb->set("total_revenue_line_items", 32);    
            //}
            return true;
        } else {
            return false;
        }
    }

    /**
     * Populate required fields
     *
     * @return string
     */
    function putRequiredFields()
    {
        if ($this->crmOb->getField("assigned_user_id") == "")
            $this->crmOb->set("assigned_user_id", $this->userID);
            $this->crmOb->set("modified_user_id", $this->userID);
            $this->crmOb->set("created_by", $this->userID);  
            $userID = $this->userID;
        if (count($this->hubspot_sugarcrm_ownermap) > 0){
            $hsOwnerID = $this->getHsVal("hubspot_owner_id");   
            lg("hsowner : " . $hsOwnerID);
            if ($hsOwnerID != ""){
                $mapUsers = array_flip($this->hubspot_sugarcrm_ownermap);
                lg("hsowner : " . print_r($mapUsers,true));
                if (isset($mapUsers[$hsOwnerID])){
                    lg("hsowner : " .$mapUsers[$hsOwnerID]);    
                    $userID = $this->getUserIDbyUserName($mapUsers[$hsOwnerID]);  
                    lg("hsowner : " .$userID);  
                    $this->crmOb->set("assigned_user_id", $userID);  
                    $this->crmOb->set("created_by", $userID); 
                    $this->crmOb->set("modified_user_id", $userID); 
                    //$assignedUser->load_relationship('teams');
                    //lg("assignedUser teams : " . print_r($assignedUser->teams,true));
                    $assignedUser = new User();
                    $assignedUser->retrieve($userID);
                    $this->crmOb->set("team_id", $assignedUser->getPrivateTeamID());
                    //$noteTeamSet       = new TeamSet();
                    //$noteteamIdsArray  = $assignedUser->getPrivateTeamID();
                    //$arrTeams = $assignedUser->get_my_teams(); 
                    $arrTeams = $this->getUserTeams($userID); 
                    //$this->crmOb->set("team_set_id", $noteTeamSet->addTeams($arrTeams));  
                    $this->crmOb->load_relationship('teams');
                    $this->crmOb->teams->add($arrTeams);                                
                }    
            }
        }
        if ($userID != "1"){
 
        }
        
        //hubspot_owner_id
    }
    function getUserTeams($userID) {
        global $db;
        lg("getUserTeams");
        $sq = 'SELECT DISTINCT rel.team_id, teams.name, teams.name_2, rel.implicit_assign' .
            ' FROM team_memberships rel RIGHT JOIN teams ON (rel.team_id = teams.id)' .
            ' WHERE rel.user_id = "'.$userID.'" AND rel.deleted = 0 ORDER BY teams.name ASC';
        $r = $db->query($sq);

        $out = [];
        $x = 0;
        while ($row = $db->fetchByAssoc($r)) {
                //$out[$row['team_id']] = Team::getDisplayName($row['name'], $row['name_2']);
                $out[] = $row['team_id'];
        }

        return $out;
    }    

    /**
     * Populate account_id
     *
     * @return string
     */
    function saveAccountIDInLead($hsID, $actID)
    {
        global $db;
        lg("saveAccountIDInLead");
        if ($hsID == "") {
            return false;
        }
        $actID = dmcDbQuote($actID);
        $hsID = dmcDbQuote($hsID);
        $sq = "update leads left join leads_cstm on id = id_c set account_id = '{$actID}',converted=1,status = 'Converted' where (account_id = '' or account_id is null) and hs_vid_c = '{$hsID}'";
        lg("saveAccountIDInLead : " . $sq);
        $db->query($sq);
    }
    /**
     * Populate account_id
     *
     * @return string
     */
    function saveAccountNameInLead($hsID, $actName)
    {
        global $db;
        lg("saveAccountNameInLead");
        if ($hsID == "") {
            return false;
        }
        $actID = dmcDbQuote($actID);
        $hsID = dmcDbQuote($hsID);
        $sq = "update leads left join leads_cstm on id = id_c set account_name = '{$actName}',converted=1,status = 'Converted' where (account_name = '' or account_name is null) and hs_vid_c = '{$hsID}'";
        lg("saveAccountNameInLead : " . $sq);
        $db->query($sq);
    }

    /**
     * Save record
     *
     * @return string
     */
    function save()
    {
        $this->putRequiredFields();
        lg("in save : " . $this->crmOb->name . " mid: " . $this->crmOb->modified_user_id);
        $this->putRequiredFields();
        if ($this->subscriptionType != "deal.propertyChange"){ //save opps to database directly
        $this->crmOb->save();
        }else{
        exit();  // DO Not save Opportunities as Amount might be 0 if revenue lines are used    
        }
        if ($this->lnkCt != "") {
            $this->saveCtOpRel($this->lnkCt, $this->crmOb->getField("id"));
            $this->lnkCt = "";
        }
        lg("save this->action: " . $this->action." crmid: ".$this->crmOb->getField("id"));
        //debug_print_backtrace();
        if ($this->action == "newContact") { // if there is a new contact and it has $this->hsOb['associations']['associatedCompanyIds'][0] it is an lead linked to account who needs conversion 
            $this->ckContactToAcctRelInHS();
            lg("save saveCtOpRelsaveCtOpRelsaveCtOpRel" . $this->lnkOpp);
            if ($this->lnkOpp != "") {
                $this->saveCtOpRel($this->crmOb->getField("id"), $this->lnkOpp);
            }
            //$this->hsOb['associations']['associatedCompanyIds']
        }
        if ($this->action == "newCompany") {    // if new company is created, check if assciated with any contacts and handle those contacts convert from lead or create new
            $relatedCtsToAct = $this->getHSAssociations($this->hsID, $this->hsAssocGetCtsFromAct);
            lg("save relatedCtsToAct");
            $relCtsIDS = $relatedCtsToAct['results'];
            if (count($relCtsIDS) > 0) {
                foreach ($relCtsIDS as $k => $v) {
                    $this->saveAccountIDInLead($v, $this->crmOb->getField("id"));
                    $this->saveAccountNameInLead($v, $this->crmOb->getField("name"));
                    $relCt = $this->ckRelatedCt($v);
                    if ($relCt->crmOb->getField("id") != "") {
                        $this->saveCtActRel($relCt->crmOb->getField("id"), $this->crmOb->getField("id"));
                    }
                }
            }
        }

        if ($this->crmModule == "Opportunity") {
            if ($this->existingLead != "") { // if there is a lead mark related fields 
                $this->updateLeadField($this->existingLead, "opportunity_id", $this->crmOb->getField("id"));
                $this->updateLeadField($this->existingLead, "converted", 1);    // mark lead as converted 
                $this->updateLeadField($this->existingLead, "status", 'Converted');    // mark lead as converted 
                    if ($this->crmOb->getField("account_id") != ""){
                        global $db;
                        $sqAct = "select * from accounts where id = '{$this->crmOb->getField("account_id")}' and deleted = 0";
                        lg("saveSQ: " . $sqAct);
                        $rAct = $db->query($sqAct);
                        $rowAct = $db->fetchByAssoc($rAct);
                        lg("saveRowAct: " . $rowAct['name']);
                            if ($rowAct['name'] != ""){
                                $this->updateLeadField($this->existingLead, "account_name", $rowAct['name']);    
                            }
                    }
        
            }
            lg("save saveCt Opportunity conv: " . $this->lnkOpp);
            lg("save saveCt Opportunity acctid: " . $this->crmOb->getField("account_id"));
            lg("save saveCt Opportunity acctname: " . $this->crmOb->getField("account_name"));
            //echo "<br>h opt cts";
            $this->handleOppCts();
        }
    }

    /**
     * Relate Contact to Company in HS
     *
     * @return string
     */
    function ckContactToAcctRelInHS()
    {
        lg("ckContactToAcctRelInHS");
        if (isset($this->hsOb['associations']['associatedCompanyIds'])) {
            if ($this->hsOb['associations']['associatedCompanyIds'][0] != "") {
                $hsActID = $this->hsOb['associations']['associatedCompanyIds'][0];
                if ($hsActID == "") {
                    return false;
                }
            }
        }
        if (isset($hsActID) and $hsActID != "") {
            $crmActID = $this->checkExistingAccount($hsActID);
            if ($crmActID == "") {  // no account inCRM
                $acc = $this->newActInCRM($hsActID);
                $crmActID = $acc->crmOb->getField("id");
            }
            lg("ckContactToAcctRelInHS LinkActTOCT: " . $this->crmOb->getField("id") . " H " . $hsActID);
            $this->saveCtActRel($this->crmOb->getField("id"), $crmActID);
        }
    }

    /**
     * Create Account in CRM
     *
     * @return string
     */
    function newActInCRM($acctId)
    {
        lg("newActInCRM");
        $acc = new dmcHSSync("updAccount");
        $acc->parentAction = $this->action;
        if ($acc->crmOb->getField("id") == "") {
            $hsAcct = $this->getHSAccount($acctId);
            $acc->hsOb = $hsAcct;
            $acc->putCrmValues();
            //$acc->crmOb->set("name",$acc->crmOb->getField("name").""); 
            $acc->crmOb->set("hs_vid_c", $acctId);
            $acc->save();
            lg("newActInCRM: " . $acc->crmOb->getField("id"));
        }
        return $acc;
    }

    /**
     * Check Existing Contact
     *
     * @return string
     */
    function checkExistingContact($id)
    {
        global $db;
        $id = dmcDbQuote($id);
        $sq = "select * from contacts left join contacts_cstm on id = id_c where deleted = 0 and hs_vid_c = '{$id}' and hs_vid_c != ''";
        lg("\n checkExistingContact: " . $sq);
        $r = $db->query($sq, true);
        $row = $db->fetchByAssoc($r);
        if ($row['id'] != "") {
            return $row['id'];
        }
    }

    /**
     * Check existing Lead
     *
     * @return string
     */
    function checkExistingLead($id)
    {
        global $db;
        $id = dmcDbQuote($id);
        $sq = "select * from leads left join leads_cstm on id = id_c where deleted = 0 and hs_vid_c = '{$id}' and hs_vid_c != ''";
        $r = $db->query($sq, true);
        $row = $db->fetchByAssoc($r);
        if ($row['id'] != "") {
            return $row['id'];
        }
    }

    /**
     * Check existing Account
     *
     * @return string
     */
    function checkExistingAccount($id)
    {
        global $db;
        $id = dmcDbQuote($id);
        $id = dmcDbQuote($id);
        $sq = "select * from accounts left join accounts_cstm on id = id_c where deleted = 0 and hs_vid_c = '{$id}' and hs_vid_c != ''";
        $r = $db->query($sq, true);
        $row = $db->fetchByAssoc($r);
        if ($row['id'] != "") {
            return $row['id'];
        }
    }

    /**
     * Check existing record
     *
     * @return string
     */
    function checkExsiting($id)
    {
        global $db;
        $this->hsID = $id;
        //$dbgBT = debug_backtrace(2);        
        //lg("checkExsiting bkTrace: ".print_r($dbgBT));
        if ($this->table_name == "leads") {
            $existingContact = $this->checkExistingContact($id);
            if ($existingContact != "") {
                $this->loadRelatedContact($existingContact);
            }
        }
        if ($this->table_name == "opportunities") {
            $fldName = "hs_dealid_c";
        } else {
            $fldName = $this->hs_vid_c;
        }
        $this->hsID = dmcDbQuote($this->hsID);
        $sq = "select * from {$this->table_name} left join {$this->table_name_cstm} on id = id_c where deleted = 0 and {$fldName} = '{$this->hsID}' and {$fldName} != ''";
        $r = $db->query($sq, true);
        $row = $db->fetchByAssoc($r);
        lg("sq checkexisting: " . $sq . " \n found: " . $row['id']);
        if ($row['id'] != "") {
            $this->crmOb->disable_row_level_security = true;
            $this->crmOb->retrieveRecord($row['id']);
            if ($this->crmModule == "Lead") {
                if ($this->crmOb->getField("contact_id") != "") {  // if we have a converted lead load the related Contact
                    $this->loadRelatedContact($this->crmOb->getField("contact_id"));  // load the contact if lead is converted      
                }
            }
        }
        $creationReplica = false;
        if (isset($_REQUEST)){
            if ($_REQUEST['mode'] == "hookCreate" and $this->crmOb->getField("id") != "") {  // we received a create command but we have it in db, ck if it is hs replica
                //$hasChanges = $this->ckCrmModifiedValues();  
                $isReplica = $this->ckCrmFldsCreatedByApp(); // HS sent back our record
                lg("ck for replica: " . $isReplica);
            }
        }

        
        //and !$isReplica
        if (isset($_REQUEST)){
            lg("Req dmcModeT1: " . $_REQUEST['dmcMode']);
            if ($_REQUEST['dmcMode'] != "hookUpdate") {
                if (($this->occurredAt == "" or $row['hs_time_c'] == "") or (($this->occurredAt != "" and $row['hs_time_c'] != "") and $this->occurredAt != $row['hs_time_c'])) {
                    if ($this->crmModule == "Lead") { // check if there is a lead related to an account . If so convert to contact
                        $actRelatedToLead = $this->getLeadFirstHsCompany();
                        if ($actRelatedToLead != "") { // if there is a lead with related account
                            $acID = $this->checkExistingAccount($actRelatedToLead);
                            $this->crmModule = "Contact";   // Don't create or update Lead if it is related to an Account, should be Contact
                            echo "<br>create contact";
                            //exit();
                            $this->action = "newContact";
                            $this->crmModule = "Contact";
                            $this->getCRMObject();
                            $this->hsOb['associations']['associatedCompanyIds'][] = $actRelatedToLead;
                        }
                    }
                    lg("mode: " . $this->mode);
                    if (($this->crmModule == "Lead" or $this->crmModule == "Contact")) {  // if not related to account, ck if related to opportunity
                        $oppCt = $this->getHSAssociations($this->hsID, 4);
                        lg("found by getHSAssociations: " . print_r($oppCt,true));
                        if (is_array($oppCt['results'])) {
                            if (isset($oppCt['results'][0])){
                                if ($oppCt['results'][0] != "") {
                                    $this->action = "newContact";
                                    $this->crmModule = "Contact";
                                    $this->getCRMObject();
                                    $existingContact = $this->checkExistingContact($id);  // Make sure to check if exists and load it if so
                                    lg("\n existing contact: " . $existingContact . " id: " . $id);
                                    if ($existingContact != "") {
                                        $this->loadRelatedContact($existingContact);
                                        $this->action = "updContact";

                                    }
                                    if ($this->parentAction == "" and $this->mode != 'hookUpdate') {    // if is a true contact save ck for related, don't loop  | also don't search for prop updates   

                                        $this->hsOb['associations']['associatedVids'] = $oppCt['results'];
                                        foreach ($oppCt['results'] as $k => $v) {
                                            $relOpp = $this->ckRelatedOpp($v);
                                        }
                                    }
                                }
                            }
                        }
                    }
                    lg("CheckTime DIFF: " . $this->occurredAt . " row ts: " . $row['hs_time_c']);
                } else {
                    lg("CheckTime DIFF, FOUND SAME " . $this->occurredAt . " row ts: " . $row['hs_time_c']);
                }
            }
        }
        //getHSAssociations($id,$relID)

    }

    /**
     * Get loadRelatedContact
     *
     * @return string
     */
    function loadRelatedContact($id)
    {
        lg("loadRelatedContact");
        $this->crmModule = "Contact";
        $this->action = "updContact";
        $this->getCRMObject();
        $this->crmOb->disable_row_level_security = true;
        $this->crmOb->retrieveRecord($id);
    }

    /**
     * Get First Account
     *
     * @return string
     */
    function getFirstHsCompany()
    {
        $hsArray = $this->hsOb;
        if (isset($hsArray['associations'])) {
            if (isset($hsArray['associations']['associatedCompanyIds'])) {
                lg("getFirstCompany: " . $hsArray['associations']['associatedCompanyIds'][0]);
                return $hsArray['associations']['associatedCompanyIds'][0];
            }
        }
        //return $this->hsID; // if no account related to opportunity, return opp id to be used with new account  
    }

    /**
     * Get HS Company
     *
     * @return string
     */
    function getLeadFirstHsCompany()
    {
        $hsArray = $this->hsOb;
        if (isset($hsArray['properties']['associatedcompanyid'])) {
            return $hsArray['properties']['associatedcompanyid']['value'];
        }
        //return $this->hsID; // if no account related to opportunity, return opp id to be used with new account  
    }

    /**
     * Get HS Value
     *
     * @return string
     */
    function getHsVal($field)
    {
        global $db;
        lg("function hsobj");
        lg($this->hsOb);
        $hsArray = $this->hsOb;
        $foundTS = "";

        if (isset($this->dateFields[$field])) {
            if (isset($hsArray['properties'][$field])) {
                if (isset($hsArray['properties'][$field]['value'])) {
                    lg("date field: " . $field . " val: " . $this->getDateVal($hsArray['properties'][$field]['value']));
                    if ($this->hs_time_c < $foundTS) {
                        $this->hs_time_c = $foundTS;
                    }
                    return $this->getDateVal($hsArray['properties'][$field]['value']);
                }
            }
        }

        if (isset($hsArray['properties'][$field])) {
            if (isset($hsArray['properties'][$field]['value'])) {
                $foundTS = $this->returnTS($hsArray['properties'][$field]);
                if ($this->hs_time_c < $foundTS) {
                    $this->hs_time_c = $foundTS;
                }
                return $db->quote($hsArray['properties'][$field]['value']);
            }
        }
    }

    /**
     * Get timestamp
     *
     * @return string
     */
    function returnTS($fldA)
    {
        $cnt = count($fldA['versions']);
        if ($cnt > 0) {
            $nmbr = $cnt - 1;
            $lastA = $fldA['versions'][$nmbr];
            if (isset($lastA['timestamp']) and $lastA['timestamp'] != "" and $lastA['timestamp'] != "0") {
                return $lastA['timestamp'];
            }
        }
    }

    /**
     * Resource
     *
     * @return string
     */
    function returnSource($field, $name)
    {
        $hsArray = $this->hsOb;
        $fld = "";
        $cnt = "";
        $fld = $hsArray['properties'][$field];
        if (isset($fld['versions']))
            $cnt = count($fld['versions']);
        if ($cnt > 0) {
            $nmbr = 0;
            $lastA = $fld['versions'][$nmbr];
            if (isset($lastA[$name]) and $lastA[$name] != "" and $lastA[$name] != "0") {
                return $lastA[$name];
            }
        }
    }

    /**
     * Get date value
     *
     * @return date
     */
    function getDateVal($date)
    {
        $date = $date / 1000;
        $date = date('Y-m-d', $date);
        return $date;
    }

    /**
     * Get HS Value
     *
     * @return string
     */
    function getHSProps($prop)
    {
        $url = $this->hsPropURL;
        $url = str_replace("objtype", $prop, $url);
        $hs = new dmcHSSender();
        $hsProp = $hs->sendRequest($url);
        $prop = json_decode($hsProp, true);
        return $prop;
    }

    /**
     * Get HS Account
     *
     * @return string
     */
    function getHSAccount($id)
    {
        if ($id == "") {
            return false;
        }
        $hsURL = $this->getHSAcctLink($id);
        $hs = new dmcHSSender();
        $acc = $hs->sendRequest($hsURL);
        $accObj = json_decode($acc, true);
        return $accObj;
    }

    /**
     * Get HS Contact
     *
     * @return string
     */
    function getHSContact($id)
    {
        $hsURL = $this->getHSCtLink($id);
        $hs = new dmcHSSender();
        $ct = $hs->sendRequest($hsURL);
        $ctObj = json_decode($ct, true);
        return $ctObj;
    }

    /**
     * Get HS Deal
     *
     * @return string
     */
    function getHSDeal($id)
    {
        $hsURL = $this->getHSCtLink($id);
        $hs = new dmcHSSender();
        $ct = $hs->sendRequest($hsURL);
        $ctObj = json_decode($ct, true);
        return $ctObj;
    }

    /**
     * Get HS Related Record
     *
     * @return string
     */
    function getHSAssociations($id, $relID)
    {
        $hsURL = $this->getHSAssocURL($id, $relID);
        lg("getHSAssociations assocID : " . $relID);
        lg("getHSAssociations assocID : " . $hsURL);
        $hs = new dmcHSSender();
        $ct = $hs->sendRequest($hsURL);
        $ctObj = json_decode($ct, true);
        return $ctObj;
    }

    /**
     * Put Account id in Contact
     *
     * @return string
     */
    function populateAcctIDinContact($ctId, $acctId)
    {
        global $db;
        $acctId = dmcDbQuote($acctId);
        $ctId = dmcDbQuote($ctId);
        $sq = "update contacts set account_id = '{$acctId} where (account_id == '' or account_id is null) and id = '{$ctId}' and deleted = 0";
        lg("populateAcctIDinContact: " . $sq);
        $db->query($sq);
    }

    /**
     * Relate Accont with Contact
     *
     * @return string
     */
    function saveCtActRel($ctId, $acctId)
    {
        /*      //GET THIS WORKING  
        $rel_name = "accounts_contacts";
        $ct->load_relationship($rel_name);
        $ct->$rel_name->add($acctId);    
        */
        global $db;
        lg("saveCtActRel");
        $ctId = dmcDbQuote($ctId);
        $acctId = dmcDbQuote($acctId);
        $sq = "select * from accounts_contacts where contact_id = '{$ctId}' and account_id = '{$acctId}' and deleted = 0";
        $r = $db->query($sq);
        $row = $db->fetchByAssoc($r);
        if ($row['id'] == "") { // don't add relationship twice
            $sq = "select * from accounts_contacts where contact_id = '{$ctId}' and primary_account = '1' and deleted = 0";
            $r = $db->query($sq);
            $rowPrimaryAct = $db->fetchByAssoc($r);

            $guid = create_guid();
            $date = date("Y-m-d H:i:s");
            $extraPrimaryIn = "";
            $extraPrimaryVal = "";
            if ($rowPrimaryAct['id'] == "") {
                $extraPrimaryIn = ',primary_account';
                $extraPrimaryVal = ',1';
            }
            $sq = "
                INSERT INTO `accounts_contacts`
                        (`id`,
                         `contact_id`,
                         `account_id`,
                         `date_modified`,
                         `deleted` {$extraPrimaryIn})
                VALUES ('{$guid}',
                    '{$ctId}',
                    '{$acctId}',
                    '{$date}',
                    0 {$extraPrimaryVal});
                ";
            lg("saveCtActRel: " . $sq);
            $db->query($sq, true);
        }
    }

    /**
     * Relate Contact with Opporunity
     *
     * @return string
     */
    function saveCtOpRel($ctId, $opId)
    {
        global $db;
        lg("saveCtOpRel");
        $ctId = dmcDbQuote($ctId);
        $opId = dmcDbQuote($opId);
        $sq = "select * from opportunities_contacts where contact_id = '{$ctId}' and opportunity_id = '{$opId}' and deleted = 0";
        //$dbg = debug_backtrace(2);
        lg("saveCtOpRel sq: ".$sq);
        lg($dbg);
        $r = $db->query($sq);
        $row = $db->fetchByAssoc($r);
        if ($row == "") {
            $guid = create_guid();
            $date = date("Y-m-d H:i:s");
            $sq = "
                INSERT INTO `opportunities_contacts`
                        (`id`,
                         `contact_id`,
                         `opportunity_id`,
                         `date_modified`,
                         `deleted`)
                VALUES ('{$guid}',
                    '{$ctId}',
                    '{$opId}',
                    '{$date}',
                    0);
                ";
            lg("saveCtOpRel: " . $sq);
            $db->query($sq);
        } else {
            lg("saveCtOpRel rel already exists");
        }
    }

}

function dmcDbQuote($param)
{
    global $db;
    return $db->quote($param);
}

/**
 * Log messages
 *
 * @return string
 */
function lg($mes)
{
    global $db;
/*    if (is_array($mes) or is_object($mes)) {
    	echo "<br>\n lgFunc: ".print_r($mes);	
	}else{
		echo "<br>\n lgFunc: ".$mes;	
	}
	echo "<br>\n ";
	return true;*/
    
    if (isset($_REQUEST['dmcHSLogLevel'])){
        $rowCk['value'] = $_REQUEST['dmcHSLogLevel'];    
    }else{
        $sqCkLogLevel = "SELECT * FROM config WHERE  name='hsLogLevel' and category = 'dmc_hs_keys'";
        $rCk = $db->query($sqCkLogLevel);
        $rowCk = $db->fetchByAssoc($rCk);
        if ($rowCk['value'] == "" or $rowCk['value'] == "-"){
            $_REQUEST['dmcHSLogLevel'] = $rowCk['value'] ;
            return true;    
        } 
    $_REQUEST['dmcHSLogLevel'] = $rowCk['value'] ;
    }
    //return true; // don't log
    //$rowCk['value'] = "fatal";
    $rowCk['value'] = str_replace("andmodule","",$rowCk['value']);
    $rowCk['value'] = "debug";
    if ($rowCk['value'] == "fatal"){
        if (is_array($mes) or is_object($mes)) {
            $GLOBALS['log']->fatal("[dmcHS]: " . $_REQUEST['hsRequest'] . " " . print_r($mes, true));
            return;
        }
        $GLOBALS['log']->fatal("\n\n[dmcHS]: " . $_REQUEST['hsRequest'] . " " . $mes);
    }
    if ($rowCk['value'] == "debug"){
        if (is_array($mes) or is_object($mes)) {
            $GLOBALS['log']->debug("[dmcHS]: " . $_REQUEST['hsRequest'] . " " . print_r($mes, true));
            return;
        }
        $GLOBALS['log']->debug("\n\n[dmcHS]: " . $_REQUEST['hsRequest'] . " " . $mes);
    }
    if ($rowCk['value'] == "info"){
        if (is_array($mes) or is_object($mes)) {
            $GLOBALS['log']->info("[dmcHS]: " . $_REQUEST['hsRequest'] . " " . print_r($mes, true));
            return;
        }
        $GLOBALS['log']->info("\n\n[dmcHS]: " . $_REQUEST['hsRequest'] . " " . $mes);
    }
}

function lgMod($req,$res)
{
    global $db;
                
    if (isset($_REQUEST['dmcHSLogLevel'])){
        $rowCk['value'] = $_REQUEST['dmcHSLogLevel'];    
    }else{
    $sqCkLogLevel = "SELECT * FROM config WHERE  name='hsLogLevel' and category = 'dmc_hs_keys'";
    $rCk = $db->query($sqCkLogLevel);
    $rowCk = $db->fetchByAssoc($rCk);
    if ($rowCk['value'] == "" or $rowCk['value'] == "-"){
        $_REQUEST['dmcHSLogLevel'] = $rowCk['value'];
        return true;    
    } 
        $_REQUEST['dmcHSLogLevel'] = $rowCk['value'];
    }
    if (stristr($rowCk['value'],"andmodule") != ""){
        //if (is_array($res) or is_object($res)){
        //    $res = json_encode($res);    
        //}
        $res = $db->quote($res);
        $id = create_guid();
        $dt = date("Y-m-d H:i:s");
        $sq = "INSERT INTO dmc_log
            (id,
             NAME,
             date_entered,
             date_modified,
             modified_user_id,
             created_by,
             description,
             deleted,
             requrl,
             reqcont,
             rescont,
             reqstatus,
             team_id,
             team_set_id,
             acl_team_set_id,
             assigned_user_id)
            VALUES ('{$id}',
                    '{$dt}',
                    '{$dt}',
                    '{$dt}',
                    '1',
                    '1',
                    '',
                    '0',
                    '',
                    '{$req}',
                    '{$res}',
                    '',
                    '1',
                    '1',
                    '1',
                    '1')";
                    //echo "<br>".$sq;
                    $db->query($sq);    
    }
    
}

//1CRM to SugarCRM adapeter
if (!class_exists("RowUpdate")) {

    class RowUpdate
    {    
        public static function blank_for_model($beanName)
        {
            include_once "modules/Contacts/Contact.php";
            include_once "modules/Accounts/Account.php";
            include_once "modules/Opportunities/Opportunity.php";
            include_once "modules/Notes/Note.php";
            $newName = $beanName . "DMC";
            $model = new ModelDef($beanName);
            
            if ($beanName == "Account"){
                $bean = new AccountDMC();    
            }
            if ($beanName == "Contact"){
                $bean = new ContactDMC();    
            }
            if ($beanName == "Lead"){
                $bean = new LeadDMC();    
            }
            if ($beanName == "Opportunity"){
                $bean = new OpportunityDMC();    
            }
            $bean->disable_team_security = true;
            // $bean = new $newName(); NOT ALLOWED BY SugarCRM Module loader scanner
            return $bean;
        }
        //function retrieveRecord
    }

    class ContactDMC extends Contact
    {
        function retrieveRecord($id)
        {
            $this->disable_row_level_security = true;
            return $this->retrieve($id);
        }

        function set($fld, $val)
        {
            $this->$fld = $val;
        }

        function getField($fld)
        {
            return $this->$fld;
        }
    }

    class LeadDMC extends Lead
    {
        function retrieveRecord($id)
        {
            $this->disable_row_level_security = true;
            return $this->retrieve($id);
        }

        function set($fld, $val)
        {
            $this->$fld = $val;
        }

        function getField($fld)
        {
            return $this->$fld;
        }
    }

    class AccountDMC extends Account
    {
        function retrieveRecord($id)
        {
            $this->disable_row_level_security = true;
            return $this->retrieve($id);
        }

        function set($fld, $val)
        {
            $this->$fld = $val;
        }

        function getField($fld)
        {
            return $this->$fld;
        }
    }

    class OpportunityDMC extends Opportunity
    {
        function retrieveRecord($id)
        {
            $this->disable_row_level_security = true;
            return $this->retrieve($id);
        }

        function set($fld, $val)
        {
            $this->$fld = $val;
        }

        function getField($fld)
        {
            return $this->$fld;
        }
    }


}else{

}

    /**
     * Check is SugarCRM
     *
     * @return string
     */
    if (!function_exists("isSugar")){ 
	    function isSugar()
	    {
	        if (is_object("SugarAutoloader")){
	            return true;    
	        }
	    /*    if (file_exists("include/config/local_config.php")) {
	            return false;
	        }*/
	        return true;                 
	    }
	}

    /**
     * Check is SuiteCRM
     *
     * @return string
     */
    function isSuiteCRM()
    {
    /*    if (file_exists("suitecrm_version.php")) {
            return true;
        }*/
        return false;
    }

        /// KEEP IT HERE FOR NOW IT IS USED FOR CONNECTION

    //echo "<br>RR: ".$result.print_r($_REQUEST);
    if (isset($_REQUEST['entryPoint']) or $_REQUEST['mode'] == 'authClient'  or $_REQUEST['mode'] == 'deAuthClient' or isset($_REQUEST['mode'])){
        if ($_REQUEST['entryPoint'] == 'dmcHSManagerC' and isset($_REQUEST['mode']) or $_REQUEST['action'] == 'deAuthClient' or $_REQUEST['mode'] == 'authClient'  or $_REQUEST['mode'] == 'deAuthClient' or isset($_REQUEST['mode'])) {
            if ($_REQUEST['mode'] == 'authClient' && $_REQUEST['client'] != '' && $_REQUEST['url'] != '' && $_REQUEST['ep'] != '') {
                $data = array(
                    'mode' => 'authClient',
                    'dmcId' => $_REQUEST['client'],
                    'retUrl' => $_REQUEST['url'],
                    'ep' => $_REQUEST['ep']
                );

                $ch = curl_init();

                curl_setopt($ch, CURLOPT_URL, $_REQUEST['url']);
                curl_setopt($ch, CURLOPT_POST, 1);
                curl_setopt(
                    $ch, CURLOPT_POSTFIELDS,
                    http_build_query($data)
                );

                // receive server response ...
                $res = curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
                $ch = dmcHSSender::secHeader($ch);
                $result = curl_exec($ch);
                
                $err = curl_error($ch);

                curl_close($ch);

                if ($result != '') {
                    echo $result;
                }

                // get HS contacts properties
    /*            $ch = curl_init();

                $url = 'https://api.hubapi.com/properties/v1/contacts/properties?hapikey=demo';
                $data = array();
                curl_setopt($ch, CURLOPT_URL, $url);
                curl_setopt($ch, CURLOPT_POST, 0);

                // receive server response ...
                $res = curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
                $ch = dmcHSSender::secHeader($ch);
                $result = curl_exec($ch);
                $err = curl_error($ch);

                curl_close($ch);

                $fp = fopen('hs_contacts_properties.json', 'w');
                fwrite($fp, $result);
                fclose($fp);*/

                // get HS deals properties
    /*            $ch = curl_init();

                $url = 'https://api.hubapi.com/properties/v1/deals/properties?hapikey=demo';
                $data = array();
                curl_setopt($ch, CURLOPT_URL, $url);
                curl_setopt($ch, CURLOPT_POST, 0);

                // receive server response ...
                $res = curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
                $ch = dmcHSSender::secHeader($ch);
                $result = curl_exec($ch);
                $err = curl_error($ch);

                curl_close($ch);

                $fp = fopen('hs_deals_properties.json', 'w');
                fwrite($fp, $result);
                fclose($fp);*/

                // get HS companies properties
    /*            $ch = curl_init();

                $url = 'https://api.hubapi.com/properties/v1/companies/properties?hapikey=demo';
                $data = array();
                curl_setopt($ch, CURLOPT_URL, $url);
                curl_setopt($ch, CURLOPT_POST, 0);

                // receive server response ...
                $res = curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
                $ch = dmcHSSender::secHeader($ch);
                $result = curl_exec($ch);
                $err = curl_error($ch);

                curl_close($ch);

                $fp = fopen('hs_companies_properties.json', 'w');
                fwrite($fp, $result);
                fclose($fp);*/


            }
            
            if ($_REQUEST['mode'] == 'cConnection' && $_REQUEST['connected'] == true && $_REQUEST['dmcId'] != '') {
                global $db;
                //re-install the logic hooks
                $arrHooks =  array(   
                 array(
                     'module' => 'Accounts',
                     'hook' => 'before_save',
                     'order' => 1,
                     'description' => 'Create update Account in HubSpot',
                     'file' => 'custom/modules/hsHookSave.php',
                     'class' => 'hsSave',
                     'function' => 'afterSave',
                 ),
                 array(
                     'module' => 'Accounts',
                     'hook' => 'before_delete',
                     'order' => 1,
                     'description' => 'Delete Account in HubSpot',
                     'file' => 'custom/modules/hsHookSave.php',
                     'class' => 'hsSave',
                     'function' => 'beforeDelete',
                 ),
                 array(
                     'module' => 'Contacts',
                     'hook' => 'before_save',
                     'order' => 1,
                     'description' => 'Create update Contact in HubSpot',
                     'file' => 'custom/modules/hsHookSave.php',
                     'class' => 'hsSave',
                     'function' => 'afterSave',
                 ),
                 array(
                     'module' => 'Contacts',
                     'hook' => 'before_delete',
                     'order' => 1,
                     'description' => 'Delete Contact in HubSpot',
                     'file' => 'custom/modules/hsHookSave.php',
                     'class' => 'hsSave',
                     'function' => 'beforeDelete',
                 ),
                 array(
                     'module' => 'Leads',
                     'hook' => 'before_save',
                     'order' => 1,
                     'description' => 'Create update Leads in HubSpot',
                     'file' => 'custom/modules/hsHookSave.php',
                     'class' => 'hsSave',
                     'function' => 'afterSave',
                 ),
                 array(
                     'module' => 'Leads',
                     'hook' => 'before_delete',
                     'order' => 1,
                     'description' => 'Delete Leads in HubSpot',
                     'file' => 'custom/modules/hsHookSave.php',
                     'class' => 'hsSave',
                     'function' => 'beforeDelete',
                 ),
                 array(
                     'module' => 'Opportunities',
                     'hook' => 'before_save',
                     'order' => 1,
                     'description' => 'Create update Opportunities in HubSpot',
                     'file' => 'custom/modules/hsHookSave.php',
                     'class' => 'hsSave',
                     'function' => 'afterSave',
                 ),
                 array(
                     'module' => 'Opportunities',
                     'hook' => 'before_delete',
                     'order' => 1,
                     'description' => 'Delete Opportunities in HubSpot',
                     'file' => 'custom/modules/hsHookSave.php',
                     'class' => 'hsSave',
                     'function' => 'beforeDelete',
                 ),
                 array(
                     'module' => 'Accounts',
                     'hook' => 'before_relationship_add',
                     'order' => 1,
                     'description' => 'Update Relation in HubSpot',
                     'file' => 'custom/modules/hsHookSave.php',
                     'class' => 'hsSave',
                     'function' => 'RelUpd',
                 ),
                 array(
                     'module' => 'Accounts',
                     'hook' => 'before_relationship_update',
                     'order' => 1,
                     'description' => 'Update Relation in HubSpot',
                     'file' => 'custom/modules/hsHookSave.php',
                     'class' => 'hsSave',
                     'function' => 'RelUpd',
                 ),
                 array(
                     'module' => 'Accounts',
                     'hook' => 'before_relationship_delete',
                     'order' => 1,
                     'description' => 'Update Relation in HubSpot',
                     'file' => 'custom/modules/hsHookSave.php',
                     'class' => 'hsSave',
                     'function' => 'RelUpd',
                 ),
                 
                 array(
                     'module' => 'Contacts',
                     'hook' => 'before_relationship_add',
                     'order' => 1,
                     'description' => 'Update Relation in HubSpot',
                     'file' => 'custom/modules/hsHookSave.php',
                     'class' => 'hsSave',
                     'function' => 'RelUpd',
                 ),
                 array(
                     'module' => 'Contacts',
                     'hook' => 'before_relationship_update',
                     'order' => 1,
                     'description' => 'Update Relation in HubSpot',
                     'file' => 'custom/modules/hsHookSave.php',
                     'class' => 'hsSave',
                     'function' => 'RelUpd',
                 ),
                 array(
                     'module' => 'Contacts',
                     'hook' => 'before_relationship_delete',
                     'order' => 1,
                     'description' => 'Update Relation in HubSpot',
                     'file' => 'custom/modules/hsHookSave.php',
                     'class' => 'hsSave',
                     'function' => 'RelUpd',
                 ),
                 
                 array(
                     'module' => 'Opportunities',
                     'hook' => 'before_relationship_add',
                     'order' => 1,
                     'description' => 'Update Relation in HubSpot',
                     'file' => 'custom/modules/hsHookSave.php',
                     'class' => 'hsSave',
                     'function' => 'RelUpd',
                 ),
                 array(
                     'module' => 'Opportunities',
                     'hook' => 'before_relationship_update',
                     'order' => 1,
                     'description' => 'Update Relation in HubSpot',
                     'file' => 'custom/modules/hsHookSave.php',
                     'class' => 'hsSave',
                     'function' => 'RelUpd',
                 ),
                 array(
                     'module' => 'Opportunities',
                     'hook' => 'before_relationship_delete',
                     'order' => 1,
                     'description' => 'Update Relation in HubSpot',
                     'file' => 'custom/modules/hsHookSave.php',
                     'class' => 'hsSave',
                     'function' => 'RelUpd',
                 ),
               
            );
/*            foreach ($arrHooks as $kArr => $vArr){

                    unset($addArr);
                    $ckArr[0] = 2;
                    $ckArr[1] = $vArr['description'];
                    $ckArr[2] = $vArr['file'];
                    $ckArr[3] = $vArr['class'];
                    $ckArr[4] = $vArr['function'];
                    
                        remove_logic_hook($vArr['module'], $vArr['hook'], $ckArr);                      

                    $addArr[0] = 2;
                    //$addArr['description'] = $vArr['description'];
                    $addArr['description'] = $vArr['description'];
                    $addArr['file'] = $vArr['file'];
                    $addArr['class'] = $vArr['class'];
                    $addArr['function'] = $vArr['function'];
                    //$addArr = $vArr;
                    unset($addArr['module']);
                    unset($addArr['hook']);
                    unset($addArr['order']);
                    //$addArr[0] = 2;

                    check_logic_hook_file($vArr['module'], $vArr['hook'], $addArr);   
            }*/
                
                if (isset($_REQUEST['mark_active'])){
                    $sq = "UPDATE config SET value = 'connected' WHERE category = 'dmc_hs_keys' AND name = 'hsDmcStatus'";
                    $result = $db->query($sq, 1);   
                    echo "<br>saved";
                    exit();                 
                }
                if (isset($_REQUEST['mark_inactive'])){
                    $sq = "UPDATE config SET value = 'disconnected' WHERE category = 'dmc_hs_keys' AND name = 'hsDmcStatus'";
                    $result = $db->query($sq, 1);                    
                    echo "<br>saved";
                    exit();   
                }
                if (isset($_REQUEST['change_log_level']) and isset($_REQUEST['level']) and $_REQUEST['level'] != ""){  //change the log level
                    $sqCkLogLevel = "SELECT * FROM config WHERE  name='hsLogLevel' and category = 'dmc_hs_keys'";
                    $rCk = $db->query($sqCkLogLevel);
                    $rowCk = $db->fetchByAssoc($rCk);
                    if  ($rowCk['category'] == ""){
                        $db->query("INSERT INTO config SET category='dmc_hs_keys', name='hsLogLevel'");   
                        
                    }
                    $newLevel = $db->quote($_REQUEST['level']);
                    $sq = "UPDATE config SET value = '{$newLevel}' WHERE category = 'dmc_hs_keys' AND name = 'hsLogLevel'";
                    $result = $db->query($sq, 1);                    
                    echo "<br>saved";
                    exit();   
                }
                if (isset($_REQUEST['check_install'])){  //check fields and hooks
                    echo "<br>check_install";
                    $sq = "SELECT * FROM fields_meta_data WHERE NAME LIKE 'hs_%'";
                    $r = $db->query($sq);
                        while ($row = $db->fetchByAssoc($r)){
                            echo "<br><br> ".print_r($row);
                        }    
                        $file = 'custom/modules/Leads/logic_hooks.php';
                        echo "<br>file: ".$file;
                        if (SugarAutoloader::fileExists($file)) {
                            require_once($file);
                            print_r($hook_array);
                        }    
                        $file = 'custom/modules/Contacts/logic_hooks.php';
                        echo "<br>file: ".$file;
                        if (SugarAutoloader::fileExists($file)) {
                            require_once($file);
                            print_r($hook_array);
                        }    
                        $file = 'custom/modules/Accounts/logic_hooks.php';
                        echo "<br>file: ".$file;
                        if (SugarAutoloader::fileExists($file)) {
                            require_once($file);
                            print_r($hook_array);
                        }    
                        $file = 'custom/modules/Opportunities/logic_hooks.php';
                        echo "<br>file: ".$file;
                        if (SugarAutoloader::fileExists($file)) {
                            require_once($file);
                            print_r($hook_array);
                        }                
                
                exit();
                }
                
                $query = "SELECT value FROM config WHERE category='dmc_hs_keys' AND name='hsDmcId'";
                $res = $db->query($query, true);
                $mod_dmcid = $db->fetchByAssoc($res);
                $dmcId = $mod_dmcid['value'];

                if ($_REQUEST['dmcId'] == $dmcId) {
                    if ($_REQUEST['connected'] == true) {
                        $sq = "UPDATE config SET value = 'connected' WHERE category = 'dmc_hs_keys' AND name = 'hsDmcStatus'";
                        $result = $db->query($sq, 1);
                    }
                }

                global $sugar_config;
                //print_r($sugar_config);
                $sver = $sugar_config['sugar_version'];
                $surl = $sugar_config['site_url'];
                //echo "<br>a: ".$surl;
                $svere = explode(".", $sver);
                $url = $surl . '/index.php?module=Administration&action=HSConfig';
                
                //if ($svere[0] == 7 or $svere[0] == 8 or $svere[0] == 9 or $svere[0] == 10) {
                    $url = $surl . '/#bwc/index.php?module=Administration&action=HSConfig';
                //}
                //$surl = str_replace("//", "/", $url);
                $surl = str_replace("//index.php","/index.php",$surl);
                //echo "<br>a :".$url;
                //exit();
                header('Location: ' . $url);
            }

            if ($_REQUEST['action'] == 'deAuthClient' && $_REQUEST['client'] != '') {

                global $db;
                $query = "SELECT value FROM config WHERE category='dmc_hs_keys' AND name='hsDmcUrl'";
                $res = $db->query($query, true);
                $mod_list = $db->fetchByAssoc($res);
                $modList = $mod_list['value'];

                $data = array(
                    'action' => 'deAuthClient',
                    'dmcId' => $_REQUEST['client'],
                );

                $ch = curl_init();

                curl_setopt($ch, CURLOPT_URL, $modList);
                curl_setopt($ch, CURLOPT_POST, 1);
                curl_setopt(
                    $ch, CURLOPT_POSTFIELDS,
                    http_build_query($data)
                );

                // receive server response ...
                $res = curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
                $ch = dmcHSSender::secHeader($ch);
                $result = curl_exec($ch);
                $err = curl_error($ch);
                //echo "res: ".$result;
                curl_close($ch);

                if ($result == '1') {
                    $sq = "UPDATE config SET value = 'disconnected' WHERE category = 'dmc_hs_keys' AND name = 'hsDmcStatus'";
                    $result = $db->query($sq, 1);

                    print 'saved';
                } else {
                    print 'error';
                }
            }

        }
    }
?>